(*.tests for rationals
   author: Stefan Karnel
   Copyright (c) Stefan Karnel 2002
   Use is subject to license terms.
   
use"../smltest/IsacKnowledge/rational.sml";
use"rational.sml";

LEGEND WN070906
   nonterm.SK   marks non-terminating examples
   ord.SK       PARTIALLY marks crucial ordering examples
   *SK*         of some (secondary) interest (on 070906)          
****************************************************************.*)

(******************************************************************
WN060104 transfer marked (*SR..*)examples to the exp-collection
 # exp_IsacCore_Simp_Rat_Cancel.xml     from rational.sml    (*SRC*)  10 exp
 # exp_IsacCore_Simp_Rat_Add.xml        from rational.sml    (*SRA*)  11 exp
 # exp_IsacCore_Simp_Rat_Mult.xml	from rational.sml    (*SRM*)   5 exp
 # exp_IsacCore_Simp_Rat_AddMult.xml	from rational.sml    (*SRAM*) 11 exp
 # exp_IsacCore_Simp_Rat_Double.xml	from rational.sml    (*SRD*)  12 exp
*******************************************************************)
"-----------------------------------------------------------------";
"table of contents -----------------------------------------------";
"-----------------------------------------------------------------";
"~~~~~BEGIN: decomment structure RationalI : RATIONALI ~~~~~~~~~~~";
"-------- ... missing WN060103 -----------------------------------";
"-------- fun monom2term,  fun poly2term' ------------------------";
"~~~~~END: decomment structure RationalI : RATIONALI ~~~~~~~~~~~~~";
"-------- cancel from: Mathematik 1 Schalk Reniets Verlag --------";
"-------- common_nominator_p ---------------------------- --------";
"-------- reverse rewrite ----------------------------------------";
"-------- 'reverse-ruleset' cancel_p -----------------------------";
"-------- norm_Rational ------------------------------------------";
"-------- numeral rationals --------------------------------------";
"-------- cancellation -------------------------------------------";
"-------- common denominator -------------------------------------";
"-------- multiply and cancel ------------------------------------";
"-------- common denominator and multiplication ------------------";
"-------- double fractions ---------------------------------------";
"-------- me Schalk I No.186 -------------------------------------";
"-------- interSteps ..Simp_Rat_Double_No-1.xml ------------------";
"-------- interSteps ..Simp_Rat_Cancel_No-1.xml ------------------";
"-------- investigate rulesets for cancel_p ----------------------";
"-------- investigate format of factout_ and factout_p_ ----------";
"-------- how to stepwise construct Scripts ----------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";
"-----------------------------------------------------------------";


"~~~~~BEGIN: decomment structure RationalI : RATIONALI ~~~~~~~~~~~";
(*.~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    tests of internal functions: to make them work, 
    out-comment (*!!!*) in knowledge/Rational.ML:
(*##!!!
structure RationalI : RATIONALI =
struct
!!!##*)

(*##!!!
end;(*struct*)
open RationalI;
!!!##*)~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~.*)

(*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
print("\n\n*********************   rational.sml - TESTS    *************************\n\n");
print("\n\n***** divide tests *****\n");
val mv_pquot1 = (#1(mv_division([(1,[1,1,1]),(1,[1,1,0]),(1,[1,0,1]),(1,[0,0,0])],[(1,[1,1,0]),(1,[0,0,0])],LEX_)));
(* result: [(1,[0,0,1]),(1,[0,0,0])] *)
if mv_pquot1=[(1,[0,0,1]),(1,[0,0,0])] then () else error ("rational.sml: example failed");

val mv_prest1 = (#2(mv_division([(1,[1,1,1]),(1,[1,1,0]),(1,[1,0,1]),(1,[0,0,0])],[(1,[1,1,0]),(1,[0,0,0])],LEX_)));
(* result: [(1,[1,0,1]),(~1,[0,0,1])] *)
if mv_prest1=[(1,[1,0,1]),(~1,[0,0,1])] then () else error ("rational.sml: example failed");

val mv_pquot2 = (#1(mv_division([(4,[2]),(8,[1]),(16,[0])],[(1,[1]),(1,[0])],LEX_)));
(* result: [(4,[1]),(4,[0])] *)
if mv_pquot2=[(4,[1]),(4,[0])] then () else error ("rational.sml: example failed");

val mv_prest2 = (#2(mv_division([(4,[2]),(8,[1]),(16,[0])],[(1,[1]),(1,[0])],LEX_)));
(* result: [(12,[0]] *)
if mv_prest2=[(12,[0])] then () else error ("rational.sml: example failed");

val mv_pquot3 = (#1(mv_division([(4,[2]),(~4,[0])],[(2,[1]),(2,[0])],LEX_)));
(* [(2,[1]),(~2,[0])] *)
if mv_pquot3=[(2,[1]),(~2,[0])] then () else error ("rational.sml: example failed");

val mv_prest3 = (#2(mv_division([(1,[2]),(~1,[0])],[(2,[1]),(2,[0])],LEX_)));
(* [(1,[2]),(~1,[0])] *)
if mv_prest3=[(1,[2]),(~1,[0])] then () else error ("rational.sml: example failed");

val mv_pquot4 = (#1(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1])],[(2,[1,0,0]),(4,[0,0,1])],LEX_)));
(* [(1,[0,1,1])] *)
if mv_pquot4=[(1,[0,1,1])] then () else error ("rational.sml: example failed");

val mv_prest4 = (#2(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1])],[(2,[1,0,0]),(4,[0,0,1])],GGO_)));
(* [(1,[1,1,1]),(~4,[0,1,2]),(4,[1,0,1]),(3,[0,0,1])] *)
if mv_prest4 =[(1,[1,1,1]),(~4,[0,1,2]),(4,[1,0,1]),(3,[0,0,1])] then () else error ("rational.sml: example failed");

val mv_pquot5 = (#1(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1]),(6,[2,1,3]),(4,[0,4,1]),(1,[2,2,1])],[(1,[0,0,1])],LEX_)));
(* [(1,[2,2,0]),(6,[2,1,2]),(3,[1,1,0]),(4,[1,0,0]),(4,[0,4,0]),(3,[0,0,0])]*)
if mv_pquot5=[(1,[2,2,0]),(6,[2,1,2]),(3,[1,1,0]),(4,[1,0,0]),(4,[0,4,0]),(3,[0,0,0])] then () else error ("rational.sml: example failed");

val mv_prest5 = (#2(mv_division([(3,[1,1,1]),(4,[1,0,1]),(3,[0,0,1]),(6,[2,1,3]),(4,[0,4,1]),(1,[2,2,1])],[(1,[0,0,1])],LEX_)));
(* [] *)
if mv_prest5=[] then () else error ("rational.sml: example failed");

(* (x^2 + 2(a+1)x + (a^2+2a+1)) / (x+a+1) = x+a+1 *)
val mv_pquot6 = (#1(mv_division([(1,[2,0,0]),(2,[1,1,0]),(2,[1,0,0]),(1,[0,2,0]),(2,[0,1,0]),(1,[0,0,0])],[(1,[1,0,0]),(1,[0,1,0]),(1,[0,0,0])],LEX_)));
if mv_pquot6=[(1,[1,0,0]),(1,[0,1,0]),(1,[0,0,0])] then () else error ("rational.sml: example failed");

val mv_prest6 = (#2(mv_division([(1,[2,0,0]),(2,[1,1,0]),(2,[1,0,0]),(1,[0,2,0]),(2,[0,1,0]),(1,[0,0,0])],[(1,[1,0,0]),(1,[0,1,0]),(1,[0,0,0])],LEX_)));
if mv_prest6=[] then () else error ("rational.sml: example failed");


print("\n\n***** MV_CONTENT-TESTS *****\n");
val mv_cont1=mv_content([(1,[2,1]),(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,1]),(1,[0,0])]);
(* [(1,[0,1]),(1,[0,0])] *)
if  mv_cont1=[(1,[0,1]),(1,[0,0])] then () else error ("rational.sml: example failed");

val mv_pp1=mv_pp([(1,[1,1]),(1,[1,0]),(1,[0,1]),(1,[0,0])]);
(*[(1,[1,0]),(1,[0,0])]*)
if mv_pp1=[(1,[1,0]),(1,[0,0])] then () else error ("rational.sml: example failed");

val mv_cont2=mv_content([(2,[1]),(4,[0])]);
(* [(2,[0])] *)
if mv_cont2=[(2,[0])] then () else error ("rational.sml: example failed");

val mv_pp2=mv_pp([(2,[1]),(4,[0])]);
(* [(1,[1]),(2,[0])] *)
if mv_pp2=[(1,[1]),(2,[0])] then () else error ("rational.sml: example failed");

val mv_cont3=mv_content[(8,[2,1,1]),(12,[1,0,2]),(10,[2,2,0]),(16,[1,1,1])];
(* [(2,[0,0,0])] *)
if mv_cont3=[(2,[0,0,0])] then () else error ("rational.sml: example failed");

val mv_pp3=mv_pp[(8,[2,1,1]),(12,[1,0,2]),(10,[2,2,0]),(16,[1,1,1])];
(* [(5,[2,2,0]),(4,[2,1,1]),(8,[1,1,1]),(6,[1,0,2])] *)
if mv_pp3=[(5,[2,2,0]),(4,[2,1,1]),(8,[1,1,1]),(6,[1,0,2])] then () else error ("rational.sml: example failed");

val mv_cont4=mv_content[(2,[2,1,0]),(3,[1,0,1]),(2,[1,1,0]),(3,[0,0,1])];
(* [(1,[0,0,0])] *)
if mv_cont4=[(1,[0,0,0])] then () else error ("rational.sml: example failed");

val mv_pp4=mv_pp [(2,[2,1,0]),(3,[1,0,1]),(2,[1,1,0]),(3,[0,0,1])];
(* [(2,[2,1,0]),(2,[1,1,0]),(3,[1,0,1]),(3,[0,0,1])] *)
if mv_pp4=[(2,[2,1,0]),(2,[1,1,0]),(3,[1,0,1]),(3,[0,0,1])] then () else error ("rational.sml: example failed");

val con1=mv_content([(9,[2,0]),(15,[1,1]),(12,[1,0]),(6,[0,2]),(12,[0,1])]);
(* [(3,[0,0])] *)
if con1=[(3,[0,0])] then () else error ("rational.sml: example failed");

val pp1=mv_pp([(9,[2,0]),(15,[1,1]),(12,[1,0]),(6,[0,2]),(12,[0,1])]);
(* [(3,[2,0]),(5,[1,1]),(4,[1,0]),(2,[0,2]),(4,[0,1])] *)
if pp1=[(3,[2,0]),(5,[1,1]),(4,[1,0]),(2,[0,2]),(4,[0,1])] then () else error ("rational.sml: example failed");

val con2=mv_content([(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])]);
(* [(1,[0,0])] *)
if con2=[(1,[0,0])] then () else error ("rational.sml: example failed");

val pp2 =mv_pp([(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])]);
(* [(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])] *)
if pp2=[(1,[2,0]),(1,[1,1]),(1,[1,0]),(1,[0,2]),(1,[0,1])] then () else error ("rational.sml: example failed");

val cont1 = mv_content [(1,[2,1,0]),(2,[2,1,0])];
(* [(3,[0,1,0])] *)
if cont1=[(3,[0,1,0])] then () else error ("rational.sml: example failed");

val pp1 = mv_pp [(1,[2,1,0]),(2,[2,1,0])];
(* [(1,[2,0,0])] *)
if pp1=[(1,[2,0,0])] then () else error ("rational.sml: example failed");

val cont2 = mv_content [(4,[1,2,0]),(2,[2,1,0])];
(* [(2,[0,1,0])] *)
if cont2=[(2,[0,1,0])] then () else error ("rational.sml: example failed");

val pp2 = mv_pp [(4,[1,2,0]),(2,[2,1,0])];
(* [(1,[2,0,0]),(2,[1,1,0])] *)
if pp2=[(1,[2,0,0]),(2,[1,1,0])] then () else error ("rational.sml: example failed");

print("\n\n\n\n********************************************************\n\n");
val cont3=mv_content [(65,[3,2,2]),(52,[3,2,1]),(26,[3,1,2]),(~95,[2,2,3]),(~76,[2,2,2]),(35,[2,2,1]),(28,[2,2,0]),(~38,[2,1,3]),(14,[2,1,1])];
if cont3=[(5,[0,2,1]),(4,[0,2,0]),(2,[0,1,1])] then () else error ("rational.sml: example failed");
val pp3=mv_pp [(65,[3,2,2]),(52,[3,2,1]),(26,[3,1,2]),(~95,[2,2,3]),(~76,[2,2,2]),(35,[2,2,1]),(28,[2,2,0]),(~38,[2,1,3]),(14,[2,1,1])];


"-------- fun monom2term,  fun poly2term' ------------------------";
"-------- fun monom2term,  fun poly2term' ------------------------";
"-------- fun monom2term,  fun poly2term' ------------------------";
val t = monom2term ((3,[2,1,0]), ["c","b","a"](*reverse ???SK-*));
term2str t = "3 * (c ^^^ 2 * b)" (*true*);

val t = monom2term ((1,[1,0]), ["b","a"]);
term2str t = "b" (*true*);

val t = poly2term ([(1,[0,0,0]),(2,[1,0,0]),(3,[2,1,0]),(4,[3,2,1])], 
		   ["c","b","a"]);
term2str t = "1 + 2 * c + 3 * (c ^^^ 2 * b) + 4 * (c ^^^ 3 * (b ^^^ 2 * a))";

val t = poly2term ([(1,[1,0]),(1,[0,1])], ["b","a"]);
term2str t = "a + b" (*true*);


~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*)
"~~~~~END: decomment structure RationalI : RATIONALI ~~~~~~~~~~~~~";
"~~~~~END: decomment structure RationalI : RATIONALI ~~~~~~~~~~~~~";
"~~~~~END: decomment structure RationalI : RATIONALI ~~~~~~~~~~~~~";


fun parse_rat str = (term_of o the o (parse thy)) str;

print("\n\n***** mv_gcd-tests *****\n");
val ggt1 = mv_gcd [(4,[2,2]),(8,[1,1]),(4,[0,0])] [(2,[1,1]),(2,[0,0])];
(* [(2,[1,1]),(2,[0,0])] *)
if ggt1=[(2,[1,1]),(2,[0,0])] then () else error ("rational.sml: example failed");

val ggt2 = mv_gcd [(8,[2,1,1]),(12,[1,0,2]),(10,[2,2,0]),(15,[1,1,1])] [(2,[2,1,0]),(3,[1,0,1]),(2,[1,1,0]),(3,[0,0,1])];
(* [(2,[1,1,0]),(3,[0,0,1])] *)
if ggt2=[(2,[1,1,0]),(3,[0,0,1])] then () else error ("rational.sml: example failed");


val ggt3 = mv_gcd [(1,[2,0]),(~2,[1,1]),(1,[0,2])] [(1,[1,0]),(~1,[0,1])];
(* [(1,[1,0]),(~1,[0,1])] *)
if ggt3=[(1,[1,0]),(~1,[0,1])] then () else error ("rational.sml: example failed");


val ggt4 = mv_gcd [(1,[2,1,0]),(2,[2,1,0])] [(5,[1,0,0])];
(* [(1,[1,0,0])] *)
if ggt4=[(1,[1,0,0])] then () else error ("rational.sml: example failed");


val ggt5 = mv_gcd [(4,[2,0]),(~8,[1,1]),(4,[0,2])] [(1,[2,0]),(~1,[0,2])];
(* [(1,[1,0]),(~1,[0,1])] *)
if ggt5=[(1,[1,0]),(~1,[0,1])] then () else error ("rational.sml: example failed");


val ggt6 = mv_gcd [(10,[2,1,1]),(14,[1,1,0]),(3,[1,0,1]),(20,[1,2,1])] [(5,[1,1,1]),(7,[2,1,1])];
(* [(1,[0,0,0])] *)
if ggt6=[(1,[1,0,0])] then () else error ("rational.sml: example failed");

print("\n\n***** kgv-tests *****\n");
val kgv1=mv_lcm [(10,[])] [(15,[])];
(* [(30,[])] *)
if kgv1=[(30,[])] then () else error ("rational.sml: example failed");

val kgv2=mv_lcm [(1,[2,0]),(~2,[1,1]),(1,[0,2])] [(1,[1,0]),(~1,[0,1])];
(* [(1,[2,0]),(~2,[1,1]),(1,[0,2])] *)
if kgv2=[(1,[2,0]),(~2,[1,1]),(1,[0,2])] then () else error ("rational.sml: example failed");

val kgv3=mv_lcm [(4,[2,0]),(~8,[1,1]),(4,[0,2])] [(1,[2,0]),(~1,[0,2])];
(* [(4,[3,0]),(~4,[2,1]),(~4,[1,2]),(4,[0,3])] *)
if kgv3=[(4,[3,0]),(~4,[2,1]),(~4,[1,2]),(4,[0,3])] then () else error ("rational.sml: example failed");

(*!!!--------
print("\n\n***** STEP_CANCEL_TESTS: *****\n");

val term2 = (term_of o the o (parse thy)) " (9 * a^^^2 * b) /  (6 * a * c)";
val div2 = term2str (step_cancel term2);
if div2 =  "3 * (a * b) * (3 * a) / (2 * c * (3 * a))" then () else error ("rational.sml: example failed");


val term1 = (term_of o the o (parse thy)) "(10 * a^^^2 * b * c + 14 * a * b + 3 * a * c + 20 * a * b^^^2 * c) / a";
val div1  = term2str(step_cancel term1);
if div1 =  "(3 * c + 14 * b + 20 * (b ^^^ 2 * c) + 10 * (a * (b * c))) * a / (1 * a)" then () else error ("rational.sml: example failed");

val term3 = (term_of o the o (parse thy)) "(10 * a^^^2 * b * c) / (1 * x * y * z) ";
val div3 = term2str(step_cancel term3);
if div3="10 * a ^^^ 2 * b * c / (1 * x * y * z)" then () else  error ("rational.sml: example failed");

--------------------------------------------------------------------------!!!*)

(*-----versuche 13.3.03-----
 val t = str2term "1 - x^^^2 - 5 * x^^^5";
 val vs=(((map free2str) o vars) t);
 val SOME ml = expanded2poly t vs;
 poly2term (ml, vs);
 poly2term'(rev(sort (mv_geq LEX_) (ml)),vs);
 poly2term'([(~5,[5]),(~1,[2]),(1,[0])], vs);
 monom2term((~5,[5]),vs);
 monom2term((~1,[2]),vs);
 val t' = monom2term((1,[0]),vs);(*uncaught exception LIST*)

 val (i,is) = (~1,[2]);
 val ttt = Const ("Groups.times_class.times", [HOLogic.realT,HOLogic.realT]---> HOLogic.realT) $
		   (Const ("uminus", HOLogic.realT --> HOLogic.realT) $
		   Free ((str_of_int o abs) i, HOLogic.realT)) $
		   powerproduct2term(is, vs);
 term2str ttt;
-------versuche 13.3.03-----*)

 val t = str2term "1 - x^^^2 - 5 * x^^^5";
 val SOME t' = expanded2polynomial t; term2str t';
"1 + - 1 * x ^^^ 2 + - 5 * x ^^^ 5";
 val t = str2term "1 - x";
 val SOME t' = expanded2polynomial t; term2str t';
"1 + - 1 * x";
 val t = str2term "1 + (-1) * x";
 val SOME t' = expanded2polynomial t; term2str t';
"1 + - 1 * x";
 val t = (term_of o the o (parse thy)) "1 + (-1) * x ^^^ 2 + (-5) * x ^^^5";
 val SOME t' = polynomial2expanded t; term2str t';
"1 - x ^^^ 2 - 5 * x ^^^ 5";


" external calculating functions test ";
" external calculating functions test ";
" external calculating functions test ";

val t1 = (term_of o the o (parse thy)) "((3 * x^^^2 + 6 *x + 3) / (2*x + 2))";
val SOME (t1',asm)= factout_p_ thy t1;
term2str t1'; terms2str asm;
"(3 + 3 * x) * (1 + 1 * x) / (2 * (1 + 1 * x))";
"[]";
val SOME (t1',asm)= cancel_p_ thy t1;
term2str t1'; terms2str asm;
"(3 + 3 * x) / 2";
"[\"1 + 1 * x ~= 0\"]";

val t = (term_of o the o (parse thy)) "((-3 * x^^^2 + 6 *x - 3) / (2*x - 2))";
val SOME (t',asm)= cancel_ thy t; 
term2str t'; terms2str asm;
"(3 - 3 * x) / 2";
"[\"-1 + x ~= 0\"]";
val SOME (t',asm)= factout_ thy t;
term2str t'; terms2str asm;
"(3 - 3 * x) * (-1 + x) / (2 * (-1 + x))";
"[]";

val t = str2term "((x+ (-1)) / (x + 1)) + ((x + 1) / (x + (-1)))";
val SOME (t',asm) = add_fraction_p_ thy t;
term2str t'; terms2str asm;
"(2 + 2 * x ^^^ 2) / (-1 + 1 * x ^^^ 2)";
"[]";
val SOME (t',asm) = common_nominator_p_ thy t; 
term2str t'; terms2str asm;
"(-1 + 1 * x) * (-1 + 1 * x) / ((1 + 1 * x) * (-1 + 1 * x)) +\n(1 + 1 * x) * (1 + 1 * x) / ((1 + 1 * x) * (-1 + 1 * x))";
"[]";

val t = str2term "((x - 1) / (x + 1)) + ((x + 1) / (x - 1))";
val SOME (t',asm) = add_fraction_ thy t;
term2str t'; terms2str asm;
"(2 + 2 * x ^^^ 2) / (-1 + x ^^^ 2)";
"[]";
val SOME (t',asm) = common_nominator_ thy t; 
term2str t'; terms2str asm;
"(-1 + x) * (-1 + x) / ((1 + x) * (-1 + x)) +\n(1 + x) * (1 + x) / ((1 + x) * (-1 + x))";
"[]";

val t = str2term "((1) / (2*x + 2)) + ((1) / (2*x + (-2))) + ((1) / ( x^^^2 + (-1)))+((1) / (x^^^2 + (-2)*x + 1))";
val SOME (t',asm) = common_nominator_p_ thy t; 
term2str t'; terms2str asm;
"1 * (1 + -2 * x + 1 * x ^^^ 2) /\n((-1 + 1 * x) * (2 * ((-1 + 1 * x) * (1 + 1 * x)))) +\n(1 * (-1 + 1 * x ^^^ 2) /\n ((-1 + 1 * x) * (2 * ((-1 + 1 * x) * (1 + 1 * x)))) +\n (1 * (-2 + 2 * x) / ((-1 + 1 * x) * (2 * ((-1 + 1 * x) * (1 + 1 * x)))) +\n  1 * (#";                
"[]";
val SOME (t',asm) = add_fraction_p_ thy t; 
term2str t'; terms2str asm;
"1 * x / (1 + -2 * x + 1 * x ^^^ 2)";
"[\"1 + 1 * x ~= 0\"]";
val SOME(t',asm) = norm_rational_ thy t;
term2str t'; terms2str asm;
"1 * x / (1 + -2 * x + 1 * x ^^^ 2)";
"[\"1 + 1 * x ~= 0\"]";

val t3 = (term_of o the o (parse thy)) "((1) / (2*x + 2)) + ((1) / (2*x - 2)) + ((1) / ( x^^^2 - 1))+((1) / (x^^^2 - 2 * x + 1))";
val SOME (t3',_) = common_nominator_ thy t3; 
val SOME (t3'',_) = add_fraction_ thy t3; 
(term2str t3'); 
(term2str t3''); 

val SOME(t4,t5) = norm_expanded_rat_ thy t3;
term2str t4;
term2str (hd(t5));



  val t=(term_of o the o (parse thy)) "(9 - x^^^2)/(9 - 6*x + x^^^2)";
  val SOME (t',_) = factout_ thy t;
  val SOME (t'',_) = cancel_ thy t;
  term2str t';
  term2str t'';
  "(3 + x) * (3 - x) / ((3 - x) * (3 - x))";
  "(3 + x) / (3 - x)";
  			   
  val t=(term_of o the o (parse thy))
	    "(9 - x^^^2) / (9 - 6*x + x^^^2) + 1 / (3 - x)";
  val SOME (t',_) = common_nominator_ thy t;
  val SOME (t'',_) = add_fraction_ thy t;
  term2str t';
  term2str t'';
  "(9 - x ^^^ 2) / ((3 - x) * (3 - x)) + 1 * (3 - x) / ((3 - x) * (3 - x))";
  "(4 + x) / (3 - x)";

(*WN021016 added -----vv---*)
val t = str2term "(9 - x^^^2) / (9 - 6*x + x^^^2) + 1";
val SOME (t',_) = common_nominator_ thy t;
val SOME (t'',_) = add_fraction_ thy t;
term2str t' = "(9 - x ^^^ 2) / (9 - 6 * x + x ^^^ 2) +\n1\
		\ * (9 - 6 * x + x ^^^ 2) / (9 - 6 * x + x ^^^ 2)" (*true*);
term2str t'' = "6 / (3 - x)" (*true*);

val t = str2term "1 + (9 - x^^^2) / (9 - 6*x + x^^^2)";
val SOME (t',_) = common_nominator_ thy t;
val SOME (t'',_) = add_fraction_ thy t;
term2str t' = "1 * (9 - 6 * x + x ^^^ 2) / (9 - 6 * x + x ^^^ 2) +\n\
		\(9 - x ^^^ 2) / (9 - 6 * x + x ^^^ 2)" (*true*);
term2str t'' = "6 / (3 - x)" (*true*);
(*WN021016 added -----^^---*)
(*WN030602 added -----vv--- no rewrite -> NONE !*)
val t = str2term "1 / a";
val NONE =  cancel_p_ thy t;
val NONE = rewrite_set_ thy false cancel_p t;
(*WN.2.6.03 added -------^^---*)

val t = str2term "(y^^^2 - x^^^2)/(y^^^2 - 2*y*x + x^^^2)";
val SOME (t',_) = factout_ thy t;
val SOME (t'',_) = cancel_ thy t;
term2str t' = "(y + x) * (y - x) / ((y - x) * (y - x))"(*true*);
term2str t'' = "(y + x) / (y - x)";
    
val t = str2term "(y^^^2 - x^^^2)/(y^^^2 - 2*y*x + x^^^2) + 1 / (y - x)";
val SOME (t',_) = common_nominator_ thy t;
val SOME (t'',_) = add_fraction_ thy t;
term2str t' =
"(-1 * x ^^^ 2 + y ^^^ 2) / ((-1 * x + y) * (-1 * x + y)) +\n1\
\ * (-1 * x + y) / ((-1 * x + y) * (-1 * x + y))" (*true*);
term2str t'' = "(-1 - x - y) / (x - y)" (*true*);

val t = str2term "(x^^^2 - y^^^2)/(x^^^2 - 2*x*y + y^^^2) + 1 / (x - y)";
val SOME (t',_) = common_nominator_ thy t;
val SOME (t'',_) = add_fraction_ thy t;
if term2str t' = "(-1 * y ^^^ 2 + x ^^^ 2) / ((-1 * y + x) * (-1 * y + x))\
\ +\n1 * (-1 * y + x) / ((-1 * y + x) * (-1 * y + x))" then ()
else error "rational.sml lex-ord 1";
if term2str t'' = "(-1 - y - x) / (y - x)" then ()
else error "rational.sml lex-ord 2";
(*WN.16.10.02 WN070905 lexicographische Ordnung erhalten ! SK.ord*)


val t = str2term "(x^^^2 - y^^^2)/(x^^^2 - 2*x*y + y^^^2)";
val SOME (t',_) = norm_expanded_rat_ thy t; 
if term2str t' = "(x + y) / (x - y)" then ()
else error "rational.sml term2poly: invalid x ^^^ 2 - y ^^^ 2 1";
(*val SOME (t'',_) = norm_rational_ thy t;
 *** RATIONALS_TERM2POLY_EXCEPTION: Invalid Polynomial 
WN.16.10.02 ?! + WN060831???SK4 
WN070905 *** term2poly: invalid = x ^^^ 2 - y ^^^ 2*)

 
val t = str2term "(9 - x^^^2)/(9 - 6*x + x^^^2) + (1)/(3 + x)";
val SOME (t',_) = norm_expanded_rat_ thy t;
if term2str t' = "(12 + 5 * x + x ^^^ 2) / (9 - x ^^^ 2)" then ()
else error "rational.sml (9 - x^^^2)/(9 - 6*x + x^^^2) +...";
(*val SOME (t'',_) = norm_rational_ thy t;
  *** RATIONALS_TERM2POLY_EXCEPTION: Invalid Polynomial WN.16.10.02 ?!
WN070906 *** term2poly: invalid = 9 - x ^^^ 2 SK.term2poly*)
 
  val t=(term_of o the o (parse thy)) 
	    "(9 + (-1)* x^^^2)/(9 + (-1)* 6*x + x^^^2) + (1)/(3 + x)";
  val SOME (t',_) = norm_expanded_rat_ thy t;
  val SOME (t'',_) = norm_rational_ thy t;
  term2str t';
  term2str t'';
  "(12 + 5 * x + x ^^^ 2) / (9 - x ^^^ 2)";
  "(12 + 5 * x + x ^^^ 2) / (9 + (-1) * x ^^^ 2)";


" examples from: Mathematik 1 Schalk Reniets Verlag ";
" examples from: Mathematik 1 Schalk Reniets Verlag ";
" examples from: Mathematik 1 Schalk Reniets Verlag ";


"-------- cancel from: Mathematik 1 Schalk Reniets Verlag --------";
"-------- cancel from: Mathematik 1 Schalk Reniets Verlag --------";
"-------- cancel from: Mathematik 1 Schalk Reniets Verlag --------";
val thy' = "Rational";
val rls' = "cancel";
val mp = "make_polynomial";

print("\n\nexample 186:\n");
print("a)\n");
val e186a'="(14 * x * y) / ( x * y )";(*SRC*)
val e186a = the (rewrite_set thy' false "cancel" e186a');
  is_expanded (parse_rat "14 * x * y");
  is_expanded (parse_rat "x * y");

print("b)\n");
val e186b'="(60 * a * b) / ( 15 * a  * b )";
val e186b = the (rewrite_set thy' false "cancel" e186b');
print("c)\n");
val e186c'="(144 * a^^^2 * b * c) / (12 * a * b * c )";
val e186c = (the (rewrite_set thy' false "cancel" e186c'))
    handle e => print_exn e;
val t = (term_of o the o (parse thy)) e186c';
atomt t;

print("\n\nexample 187:\n");
print("a)\n");
val e187a'="(12 * x * y) / (8 * y^^^2 )";(*SRC*)
val e187a = the (rewrite_set thy' false "cancel" e187a');
print("b)\n");
val e187b'="(8 * x^^^2 * y * z ) / (18 * x * y^^^2 * z )";
val e187b = the (rewrite_set thy' false "cancel" e187b');
print("c)\n");
val e187c'="(9 * x^^^5 * y^^^2 * z^^^4) / (15 * x^^^6 * y^^^3 * z )";(*SRC*)
val e187c = the (rewrite_set thy' false "cancel" e187c');

"example 188:";
val e188a'="(-8 + 8 * x) / (-9 + 9 * x)";(*SRC*)
val e188a = the (rewrite_set thy' false "cancel" e188a');
  is_expanded (parse_rat "8 * x + -8");
(* e188a = ("8 / 9",["not ((-1) + x = 0)"]) then () 13.3.03*)
if e188a = ("8 / 9",["-1 + x ~= 0"]) then ()
else error "rational.sml: e188a new behaviour";
val SOME (t,_) = rewrite_set thy' false mp 
			     "(8*((-1) + x))/(9*((-1) + x))";
print("b)\n");
val e188b'="(-15 + 5 * x) / (-18 + 6 * x)";(*SRC*)
val SOME (t,_) = rewrite_set thy' false "cancel" e188b';
t = "5 / 6" (*true*);
print("c)\n");

val e188c'="( a + -1 * b ) / ( b + -1 * a )";
val e188c = the (rewrite_set thy' false "cancel_p" e188c');
(*is_expanded (parse_rat "a + -1 * b");*)
val SOME (t,_) = 
    rewrite_set thy' false mp "((-1)*(b + (-1) * a))/(1*(b + (-1) * a))";
if t= "(a + -1 * b) / (-1 * a + b)"  then()
else error "rational.sml: e188c new behaviour";

print("\n\nexample 190:\n");
print("c)\n");
val e190c'="( 27 * a^^^3 + 9 * a^^^2 + 3 * a + 1 ) / ( 27 * a^^^3 + 18 * a^^^2 + 3 * a )";
val e190c = the (rewrite_set thy' false "cancel" e190c');
val SOME (t,_) = rewrite_set thy' false mp "((1 + 9 * a ^^^ 2)*(1 + 3 * a))/((3 * a + 9 * a ^^^ 2)*(1 + 3 * a))";
if t = "(1 + 3 * a + 9 * a ^^^ 2 + 27 * a ^^^ 3) /\n(3 * a + 18 * a ^^^ 2 + 27 * a ^^^ 3)" then ()
else error "rational.sml: e190c new behaviour";

print("\n\nexample 191:\n");
print("a)\n");
val e191a'="( x^^^2 + -1 * y^^^2 ) / ( x + y )";
(*WN.23.10.02-------
val e191a = the (rewrite_set thy' false "cancel" e191a'); 
  is_expanded (parse_rat "x^^^2 + -1 * y^^^2");
  false;
  is_expanded (parse_rat "x + y");
  true; -----------*)
val SOME (t,_) = rewrite_set thy' false mp "((x + (-1) * y)*(x + y))/((1)*(x + y))";
(* t="(x ^^^ 2 + -1 * y ^^^ 2) / (x + y)" then() WN.13.3.03*)
if t="(x ^^^ 2 + -1 * y ^^^ 2) / (x + y)" then()
else error "rational.sml: e191a new behaviour";

print("c)\n");
val e191c'="( 9 * x^^^2 + -30 * x + 25 ) / ( 9 * x^^^2 + -25 )";
(*WN.23.10.02-------
val e191c = the (rewrite_set thy' false "cancel" e191c');
  is_expanded (parse_rat "9 * x^^^2 + -30 * x + 25");
  false;
  is_expanded (parse_rat "25 + -30*x + 9*x^^^2");
  false;
  is_expanded (parse_rat "-25 + 9*x^^^2");
  true;------------*)
val SOME (t,_) = rewrite_set thy' false mp "(((-5) + 3 * x)*((-5) + 3 * x))/((5 + 3 * x)*((-5) + 3 * x))";
(* t="(25 + ((-30) * x + 9 * x ^^^ 2)) / ((-25) + 9 * x ^^^ 2)"then() 13.3.03*)
if t= "(25 + -30 * x + 9 * x ^^^ 2) / (-25 + 9 * x ^^^ 2)" then()
else error "rational.sml: 'e191c' new behaviour";


print("\n\nexample 192:\n");
print("b)\n");
val e192b'="( 7 * x^^^3 + -1 * x^^^2 * y ) / ( 7 * x * y^^^2 + -1 *  y^^^3 )";
(*WN.23.10.02-------
val e192b = the (rewrite_set thy' false "cancel" e192b');
-------------------*)
val SOME (t',_) = rewrite_set thy' false mp "((x ^^^ 2)*(7 * x + (-1) * y))/((y ^^^ 2)*(7 * x + (-1) * y))";
if t' = "(7 * x ^^^ 3 + -1 * x ^^^ 2 * y) / (7 * x * y ^^^ 2 + -1 * y ^^^ 3)"
(*"(-1 * y * x ^^^ 2 + 7 * x ^^^ 3) / (-1 * y ^^^ 3 + 7 * x * y ^^^ 2)"WN050929*)
then () else error "rational.sml: 'e192b' new behaviour";
(*^^^ works with MG's simplifier vvv*)
val t =str2term"((x ^^^ 2)*(7 * x + (-1) * y))/((y ^^^ 2)*(7 * x + (-1) * y))";
val SOME (t',_) = rewrite_set_ Isac.thy false make_polynomial t;
if term2str t' = "(7 * x ^^^ 3 + -1 * x ^^^ 2 * y) / (7 * x * y ^^^ 2 + -1 * y ^^^ 3)" then () else error "rational.sml: 'e192b'MG new behaviour";


print("\n\nexample 193:\n");
print("a)\n");
val e193a'="( x^^^2 + -6 * x + 9 ) / ( x^^^2 + -9 )";
(*WN.23.10.02-------
val e193a = the (rewrite_set thy' false "cancel" e193a');
-------------------*)
print("b)\n");
val e193b'="( x^^^2 + -8 * x + 16 ) / ( 2 * x^^^2 + -32 )";
(*WN.23.10.02-------
val e193b = the (rewrite_set thy' false "cancel" e193b');
print("c)\n");
val e193c'="( 2 * x + -50 * x^^^3 ) / ( 25 * x^^^2 + -10 * x + 1 )";
val SOME(t,_) = rewrite_set thy' false "cancel" e193c';
-------------------*)

val wn01 = "(-25 + 9*x^^^2)/(5 + 3*x)";
val SOME (t,_) = rewrite_set thy' false "cancel" wn01;
(* t = "((-5) + 3 * x) / 1" then () WN.13.3.03*)
if t = "(-5 + 3 * x) / 1" then ()
else error "rational.sml: new behav. in cancel wn01";


"-------- common_nominator_p ---------------------------- --------";
"-------- common_nominator_p ---------------------------- --------";
"-------- common_nominator_p ---------------------------- --------";
val rls' = "common_nominator_p";

print("\n\nexample 204:\n");
print("a)\n");
val e204a'="((5 * x) / 9) + ((3 * x) / 9) + (x / 9)";
val e204a = the (rewrite_set thy' false "common_nominator_p" e204a');
print("b)\n");
val e204b'="5 / x + -3 / x + -1 / x";
val e204b = the (rewrite_set thy' false "common_nominator_p" e204b');

print("\n\nexample 205:\n");
print("a)\n");
val e205a'="((4 * x + 7) / 8) + ((4 * x + 3) / 8)";
val e205a = the (rewrite_set thy' false "common_nominator_p" e205a');
print("b)\n");
val e205b'="((5 * x + 2) / 3) + ((-2 * x + 1) / 3)";
val e205b = the (rewrite_set thy' false "common_nominator_p" e205b');

print("\n\nexample 206:\n");
print("a)\n");
val e206a'="((5 * x + 4) / (2 * x + -1)) + ((9 * x + 5) / (2 * x + -1))";
val e206a = the (rewrite_set thy' false "common_nominator_p" e206a'); 
print("b)\n");
val e206b'="((17 * x + -23) / (5 * x + 4)) + ((-25 + -17 * x) / (5 * x + 4))";
val e206b = the (rewrite_set thy' false "common_nominator_p" e206b');

print("\n\nexample 207:\n");
val e207'="((3 * x * y + 3 * y) / (x * y)) + ((5 * x * y + 7 * y) / (x * y)) + ((9 * x * y + -2 * y) / (x * y)) + ((x * y + 4 * y) / (x * y)) ";
val e207 = the (rewrite_set thy' false "common_nominator_p" e207'); 

print("\n\nexample 208:\n");
val e208'="((3 * x + 2) / (x + 2)) + ((5 * x + -1) / (x + 2)) + ((-7 * x + -3) / (x + 2)) + ((-1 * x + -3) / (x + 2)) ";
val e208 = the (rewrite_set thy' false "common_nominator_p" e208'); 

print("\n\nexample 209:\n");
val e209'="((3 * x + -7 * y + 3 * z) / (4)) + ((2 * x + 17 * y + 10 * z) / (4)) + ((-1 * x + 2 * y + z) / (4)) ";
val e209 = the (rewrite_set thy' false "common_nominator_p" e209'); 

print("\n\nexample 210:\n");
val e210'="((2 * x + 3 +  -1 * x^^^2) / (5 * x)) + ((5 * x^^^2 + -2 * x + 1) / (5 * x)) + ((-3 * x^^^2 + -2 * x + 1) / (5 * x)) + ((-1 * x^^^2 + -3 * x + -5) / (5 * x)) ";
val e210 = the (rewrite_set thy' false "common_nominator_p" e210'); 

print("\n\nexample 211:\n");
print("a)\n"); 
val e211a'="((b) / (a + -1 * b)) + ((-1 * a) / (a + -1 * b))"; 
val e211a = the (rewrite_set thy' false "common_nominator_p" e211a'); 
print("b)\n");
val e211b'="((b) / (b^^^2 + -1 * a^^^2)) + ((-1 * a) / (b^^^2 + -1 * a^^^2))";
val e211b = the (rewrite_set thy' false "common_nominator_p" e211b');

print("\n\nexample 212:\n");
print("a)\n");
val e212a'="((4) / (x)) + ((-3) / (y)) + -1";
val e212a = the (rewrite_set thy' false "common_nominator_p" e212a'); 
print("b)\n");
val e212b'="((4) / (x)) + ((-5) / (y)) + ((6) / (x*y))";
val e212b = the (rewrite_set thy' false "common_nominator_p" e212b');

print("\n\nexample 213:\n");
print("a)\n"); 
val e213a'="((5 * x) / (3 * y^^^2)) + ((19 * z) / (6 * x * y)) +  ((-2 * x) / (3 * y^^^2)) + ((7 * y^^^2) / (6 * x^^^2)) ";
val e213a = the (rewrite_set thy' false "common_nominator_p" e213a'); 
print("b)\n"); 
val e213b'="((2 * b) / (3 * a^^^2)) + ((3 * c) / (7 * a * b)) +  ((4 * b) / (3 * a^^^2)) + ((3 * a) / (7 * b^^^2))";
val e213b = the (rewrite_set thy' false "common_nominator_p" e213b');

print("\n\nexample 214:\n");
print("a)\n");
val e214a'="((3 * x + 2 * y + 2 * z) / (4)) + ((-5 * x + -3 * y) / (3)) + ((x + y + -2 * z) / (2))";
val e214a = the (rewrite_set thy' false "common_nominator_p" e214a'); 
print("b)\n");
val e214b'="((5 * x + 2 * y + z) / (2)) + ((-7 * x + -3 * y) / (3)) + ((3 * x + 6 * y + -1 * z) / (12))";
val e214b = the (rewrite_set thy' false "common_nominator_p" e214b');

print("\n\nexample 216:\n");
print("a)\n"); 
val e216a'="((2 * b + 3 * c) / (a * c)) + ((3 * a + b) / (a * b)) + ((-2 * b^^^2 + -3 * a * c) / (a * b * c))";
val e216a = the (rewrite_set thy' false "common_nominator_p" e216a');  
print("b)\n");
val e216b'="((2 * a + 3 * b) / (b * c)) + ((3 * c + a) / (a * c)) + ((-2 * a^^^2 + -3 * b * c) / (a * b * c))";
val e216b = the (rewrite_set thy' false "common_nominator_p" e216b');

print("\n\nexample 217:\n");
val e217'="((z + -1) / (z)) + ((3 * z ^^^2 + -6 * z + 5) / (z^^^2)) + ((-4 * z^^^3 + 7 * z^^^2 + -5 * z + 5) / (z^^^3))";
val e217 = the (rewrite_set thy' false "common_nominator_p" e217'); 


val rls' = "common_nominator";
print("\n\nexample 218:\n"); 
val e218'="((9 * a^^^3 - 5 * a^^^2 + 2 * a + 8) / (108 * a^^^4)) + ((-5 * a + 3 * a^^^2 + 4) / (8 * a^^^3)) + ((-261 * a^^^3 + 19 * a^^^2 + -112 * a + 16) / (216 * a^^^4))";
val e218 = the (rewrite_set thy' false "common_nominator" e218'); 

print("\n\nexample 219:\n");
print("a)\n");
val e219a'="((1) / (y + 1)) + ((1) / (y + 2)) + ((1) / (y + 3))";
val e219a = the (rewrite_set thy' false "common_nominator" e219a');
print("b)\n");
val e219b'="((1) / (x + 1)) + ((1) / (x + 2)) + ((-2) / (x + 3))";
val e219b = the (rewrite_set thy' false "common_nominator" e219b'); 

print("\n\nexample 220:\n");
print("a)\n");
val e220a'="((17) / (5 * r + -2)) + ((-13) / (2 * r + 3)) + ((4) / (3 * r + -5))";
val e220a = the (rewrite_set thy' false "common_nominator" e220a');
print("b)\n");
val e220b'="((20 * a) / (a + -3)) + ((-19 * a) / (a + -4)) + ((a) / (a + -5))";
val e220b = the (rewrite_set thy' false "common_nominator" e220b'); 

print("\n\nexample 221:\n");
print("a)\n");
val e221a'="((a + b) / (a + -1 * b)) + ((a + -1 * b) / (a + b))";
val e221a = the (rewrite_set thy' false "common_nominator" e221a');
print("b)\n");
val e221b'="((x + -1 * y) / (x + y)) + ((x + y) / (x + -1 * y)) ";
val e221b = the (rewrite_set thy' false "common_nominator" e221b');

print("\n\nexample 222:\n");
print("a)\n");
val e222a'="((1 + -1 * x) / (1 + x)) + ((-1 + -1 * x) / (1 + -1 * x)) + ((4 * x) / (1 + -1 * x^^^2))";
val e222a = the (rewrite_set thy' false "common_nominator" e222a');
print("b)\n");
val e222b'="((1 + x ) / (1 + -1 * x)) + ((-1 + x) / (1 + x)) + ((2 * x) / (1 + -1 * x^^^2))";
val e222b = the (rewrite_set thy' false "common_nominator" e222b'); 

print("\n\nexample 225:\n");
print("a)\n");
val e225a'="((6 * a) / (a^^^2 + -64)) + ((a + 2) / (2 * a + 16)) + ((-1) / (2))";
val e225a = the (rewrite_set thy' false "common_nominator" e225a');
print("b)\n");
val e225b'="((a + 2 ) / (2 * a + 12)) + ((4 * a) / (a^^^2 + -36)) + ((-1) / (2))";
val e225b = the (rewrite_set thy' false "common_nominator" e225b'); 

print("\n\nexample 226:\n");
print("a)\n");
val e226a'="((35 * z) / (49 * z^^^2 + -4)) + -1 + ((14 * z + -1) / (14 * z + 4)) ";
val e226a = the (rewrite_set thy' false "common_nominator" e226a');
print("b)\n"); 
val e226b'="((45 * a * b) / (25 * a^^^2 + -9 * b^^^2)) + ((20 * a + 3 * b) / (10 * a + 6 * b))  + -2";
val e226b = the (rewrite_set thy' false "common_nominator" e226b');  

print("\n\nexample 227:\n");
print("a)\n");
val e227a'="((6 * z + 11) / (6 * z + 14)) + ((9 * z ) / (9 * z^^^2 + -49)) + -1 ";
val e227a = the (rewrite_set thy' false "common_nominator" e227a');
print("b)\n");
val e227b'="((16 * a + 37 * b) / (4 * a + 10 * b)) + ((6 * a * b) / (4 * a^^^2 + -25 * b^^^2)) + -4 ";
val e227b = the (rewrite_set thy' false "common_nominator" e227b'); 

print("\n\nexample 228:\n");
print("a)\n");
val e228a'="((7 * a + 11) / (3 * a^^^2 + -3)) + ((-2 * a + -1) / (a^^^2 + -1 * a)) + ((-1) / (3 * a + 3))";
val e228a = the (rewrite_set thy' false "common_nominator" e228a'); 
print("b)\n");
val e228b'="((11 * z + 2 * b) / (4 * b * z + -8 * b^^^2)) + ((-8 * z) / (z^^^2 + -4 * b^^^2)) + ((-9 * z + -2 * b) / (4 * b * z + 8 * b^^^2))";
val e228b = the (rewrite_set thy' false "common_nominator" e228b');  


print("\n\nexample 229:\n");
print("a)\n");
val e229a'="((5 * x^^^2 + y) / (x + 2 * y)) + ((-8 * x^^^3 + 4 * x^^^2 * y + 3 * x * y) / (x^^^2 + -4 * y^^^2)) + ((3 * x^^^2 + -4 * y) / (x + -2 * y))";
val e229a = the (rewrite_set thy' false "common_nominator" e229a'); 
print("b)\n");
val e229b'="((7 * x^^^2 + y) / (x + 3 * y)) + ((-24 * x^^^2 * y + 5 * x * y + 21 * y^^^2) / (x^^^2 + -9 * y^^^2)) + ((4 * x^^^2 + -6 * y) / (x + -3 * y))"; 
val e229b = the (rewrite_set thy' false "common_nominator" e229b'); 
 
print("\n\nexample 230:\n");
print("a)\n"); 
val e230a'="((5 * x^^^2 + y) / (2 * x + y)) + ((-16 * x^^^3 + 2 * x^^^2 * y + 6 * x * y) / (4 * x^^^2 + -1 * y^^^2)) + ((3 * x^^^2 + -4 * y) / (2 * x + -1 * y))";
val e230a = the (rewrite_set thy' false "common_nominator" e230a');
print("b)\n");
val e230b'="((7 * x^^^2 + y) / (3 * x + y)) + ((-3 * x^^^3  + 15 * x * y + -7 * x^^^2 * y + 7 * y^^^2) / (9 * x^^^2 + -1 * y^^^2)) + ((4 * x^^^2 + -6 * y) / (3 * x + -1 * y))";
val e230b = the (rewrite_set thy' false "common_nominator" e230b');

print("\n\nexample 231:\n");
print("a)\n");
val e231a'="((2 * x + 5 * y) / (x)) + ((2 * x^^^3 + -5 * y^^^3 + 3 * x * y^^^2) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-3 * x + -6 * y) / (x + -1 * y))";
val e231a = the (rewrite_set thy' false "common_nominator" e231a'); 
print("b)\n");
val e231b'="((6 * x + 2 * y) / (x)) + ((6 * x^^^2 * y + -4 * x * y^^^2 + -2 * y^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-5 * x + -3 * y) / (x + -1 * y))";
val e231b = the (rewrite_set thy' false "common_nominator" e231b');

print("\n\nexample 232:\n");
print("a)\n");
val e232a'="((2 * x + 3 * y) / (x)) + ((4 * x^^^3 + -1 * x * y^^^2 + -3 * y^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-5 * x + -6 * y) / (x + -1 * y))";
val e232a = the (rewrite_set thy' false "common_nominator" e232a'); 
print("b)\n");
val e232b'="((5 * x + 2 * y) / (x)) + ((2 * x^^^3 + -3 * x * y^^^2 + 3 * x^^^2 * y + -2 * y^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-6 * x + -3 * y) / (x + -1 * y))";
val e232b = the (rewrite_set thy' false "common_nominator" e232b');

print("\n\nexample 233:\n");
print("a)\n");
val e233a'="((5 * x + 6 * y) / (x)) + ((5 * x * y^^^2 + -6 * y^^^3 + -2 * x^^^3 + 3 * x^^^2 * y) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-2 * x + -3 * y) / (x + -1 * y))";
val e233a = the (rewrite_set thy' false "common_nominator" e233a'); 
print("b)\n");
val e233b'="((6 * x + 5 * y) / (x)) + ((4 * x^^^2 * y + 3 * x * y^^^2 + -5 * y^^^3 + -2 * x^^^3) / (x^^^3 + -2 * x^^^2 * y + x * y^^^2)) + ((-3 * x + -2 * y) / (x + -1 * y))";
val e233b = the (rewrite_set thy' false "common_nominator" e233b');

print("\n\nexample 234:\n");
print("a)\n");
val e234a'="((5 * a + b) / (2 * a * b + -2 * b^^^2)) + ((-3 * a + -1 * b) / (2 * a * b + 2 * b^^^2)) + ((-2 * a) / (a^^^2 + -1 * b^^^2))";
val e234a = the (rewrite_set thy' false "common_nominator" e234a'); 
print("b)\n"); 
val e234b'="((5 * a + 3 * b) / (6 * a * b + -18 * b^^^2)) + ((-3 * a + -3 * b) / (6 * a * b + 18 * b^^^2)) + ((-2 * a) / (a^^^2 + -9 * b^^^2)) ";
val e234b = the (rewrite_set thy' false "common_nominator" e234b');  

print("\n\nexample 235:\n");
print("a)\n");
val e235a'="((10 * x + 3 * y) / (12 * x * y + -18 * y^^^2)) + ((-6 * x + -3 * y) / (12 * x * y + 18 * y^^^2)) + ((-4 * x) / (4 * x^^^2 + -9 * y^^^2))";
val e235a = the (rewrite_set thy' false "common_nominator" e235a'); 
print("b)\n"); 
val e235b'="((8 * a + b) / (4 * a * b + -2 * b^^^2)) + ((-4 * a + -1 * b) / (4 * a * b + 2 * b^^^2)) + ((-2 * a) / (4 * a^^^2 + -1 * b^^^2)) ";
val e235b = the (rewrite_set thy' false "common_nominator" e235b');  
 
print("\n\nexample 236:\n");
print("a)\n"); 
val e236a'="((8 * a + 5 * b) / (20 * a * b + -50 * b^^^2)) + ((-4 * a + -5 * b) / (20 * a * b + 50 * b^^^2)) + ((-2 * a) / (4 * a^^^2 + -25 * b^^^2))";
val e236a = the (rewrite_set thy' false "common_nominator" e236a');  
print("b)\n");   
val e236b'="((24 * x + y) / (6 * x * y + -2 * y^^^2)) + ((-18 * x + -1 * y) / (6 * x * y + 2 * y^^^2)) + ((-15 * x) / (9 * x^^^2 + -1 * y^^^2)) ";
val e236b = the (rewrite_set thy' false "common_nominator" e236b');  


val rls' = "cancel";
print("\n\nexample heuberger:\n");
val eheu'="(x^^^4 + x * y + x^^^3 * y + y^^^2) / (x + 5 * x^^^2 + y + 5 * x * y + x^^^2 * y^^^3 + x * y^^^4)";
val eheu = the (rewrite_set thy' false "cancel" eheu');

val rls' = "common_nominator_p";
print("\n\nexample stiefel:\n");
val est1'="(7) / (-14) + (-2) / (4)";
val est1 = the (rewrite_set thy' false "common_nominator_p" est1');
if est1 = ("-1 / 1",[]) then ()
else error "new behaviour in rational.sml: est1'";
    
val t = (term_of o the o (parse thy))
"(9 - x ^^^ 2) / (9 - 6 * x + x ^^^ 2)";
val SOME (t',_) = factout_ thy t;
term2str t';
"(3 + x) * (3 - x) / ((3 - x) * (3 - x))";
    

"-------- reverse rewrite ----------------------------------------";
"-------- reverse rewrite ----------------------------------------";
"-------- reverse rewrite ----------------------------------------";

(*WN.28.8.02: tests for the 'reverse-rewrite' functions:
  these are defined in Rationals.ML and stored in 
  the 'reverse-ruleset' cancel*)

(*the term for which reverse rewriting is demonstrated*)
  val t = (term_of o the o (parse thy))
	      "(9 - x ^^^ 2) / (9 + 6 * x + x ^^^ 2)";
  val Rrls {scr=Rfuns {init_state=ini,locate_rule=loc,
  		       next_rule=nex,normal_form=nor,...},...} = cancel;

(*normal_form produces the result in ONE step*)
  val SOME (t',_) = nor t;
  term2str t';

(*initialize the interpreter state used by the 'me'*)
  val (t,_,revsets,_) = ini t;

(*find the rule 'r' to apply to term 't'*)
  val SOME r = nex revsets t;
  (*val r = Thm ("sym_#mult_2_3","6 = 2 * 3") : rule*)

(*check, if the rule 'r' applied by the user to 't' belongs to the ruleset;
  if the rule is OK, the term resulting from applying the rule is returned,too;
  there might be several rule applications inbetween,
  which are listed after the head in reverse order*)
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
  "(9 - x ^^^ 2) / (3 ^^^ 2 + 6 * x + x ^^^ 2)";

(*find the next rule to apply*)
  val SOME r = nex revsets t;
  (*val r = Thm ("sym_#power_3_2","9 = 3 ^^^ 2") : rule*)

(*check the next rule*)
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
  "(3 ^^^ 2 - x ^^^ 2) / (3 ^^^ 2 + 6 * x + x ^^^ 2)";

(*find and check the next rules, rewrite*)
  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
  "(3 ^^^ 2 - x ^^^ 2) / (3 ^^^ 2 + 2 * 3 * x + x ^^^ 2)";

  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
  "(3 - x) * (3 + x) / (3 ^^^ 2 + 2 * 3 * x + x ^^^ 2)";

  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
  "(3 - x) * (3 + x) / ((3 + x) * (3 + x))";

  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  val ss = term2str t;
  if ss = "(3 - x) / (3 + x)" then ()
  else error "rational.sml: new behav. in rev-set cancel";
  terms2str asm; 


"-------- 'reverse-ruleset' cancel_p -----------------------------";
"-------- 'reverse-ruleset' cancel_p -----------------------------";
"-------- 'reverse-ruleset' cancel_p -----------------------------";
(*WN.11.9.02: the 'reverse-ruleset' cancel_p*)

(*the term for which reverse rewriting is demonstrated*)
val t = str2term "(9 + (-1)*x^^^2) / (9 + ((-6)*x + x^^^2))";
val Rrls {scr=Rfuns {init_state=ini,locate_rule=loc,
		       next_rule=nex,normal_form=nor,...},...} = cancel_p;

(*normal_form produces the result in ONE step*)
val SOME (t',_) = nor t; 
term2str t' = "(3 + 1 * x) / (3 + -1 * x)";

(*initialize the interpreter state used by the 'me'*)
val SOME (t', asm) = cancel_p_ thy t;
term2str t' = "(3 + x) / (3 + -1 * x)" (*true*);
terms2str asm = "[\"3 + -1 * x ~= 0\"]" (*true*);
val (t,_,revsets,_) = ini t;

(* WN.10.10.02: dieser Fall terminiert nicht 
           (make_polynomial enth"alt zu viele rules)
WN060823 'init_state' requires rewriting on specified location in the term
print_depth 99; Rfuns; print_depth 3;
WN060831 cycling "sym_order_mult_rls_" "sym_real_mult_assoc"
         as was with make_polynomial before ?!?*)

val SOME r = nex revsets t;
eq_Thm (r, Thm ("sym_#power_Float ((3,0), (0,0)) __ ((2,0), (0,0))", 
		mk_thm Rational.thy "9 = 3 ^^^ 2"));
(*WN060831 *** id_of_thm
           Exception- ERROR raised ...
val (r,(t,asm))::_ = loc revsets t r;
term2str t;

  val SOME r = nex revsets t;
  val (r,(t,asm))::_ = loc revsets t r;
  term2str t;
*)

print "\n\n\n******************  all tests successfull  *************************\n";



(*WN.17.3.03 =========================================================vvv---*)
"-------- norm_Rational ------------------------------------------";
"-------- norm_Rational ------------------------------------------";
"-------- norm_Rational ------------------------------------------";
val t = str2term "(3*x+5)/18 - x/2  - -(3*x - 2)/9 = 0";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "1 / 18 = 0" then () else error "rational.sml 1";

val t = str2term "(17*x - 51)/9 - (-(13*x - 3)/6) + 11 - (9*x - 7)/4 = 0";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "(237 + 65 * x) / 36 = 0" then () 
else error "rational.sml 2";

val t = str2term "(1/2 + (5*x)/2)^^^2 - ((13*x)/2 - 5/2)^^^2 - (6*x)^^^2 + 29";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
(*before 040209:if term2str t' = "(23 + (35 * x + -72 * x ^^^ 2)) / 1"then()*) 
if term2str t' = "23 + 35 * x + -72 * x ^^^ 2" then ()
else error "rational.sml 3";
(*trace_rewrite:=true;*)
val t = str2term "Not (6*x is_atom)";
val SOME (t',_) = rewrite_set_ thy false powers_erls t; term2str t';
"True";
val t = str2term "1 < 2";
val SOME (t',_) = rewrite_set_ thy false powers_erls t; term2str t';
"True";
val t = str2term "(6*x)^^^2";
val SOME (t',_) = rewrite_ thy dummy_ord powers_erls false 
			   (num_str @{thm realpow_def_atom) t;
term2str t';
trace_rewrite:=false;

val t = str2term "-1 * (-2 * (5 / 2 * (13 * x / 2)))";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "65 * x / 2" then () else error "rational.sml 4";

val t = str2term "1 - ((13*x)/2 - 5/2)^^^2";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
(*bef.040209: if term2str t' = "(-21 + (130 * x + -169 * x ^^^ 2)) / 4"then()*)
if term2str t' = "(-21 + 130 * x + -169 * x ^^^ 2) / 4" then () 
else error "rational.sml 5";

(*SRAM Schalk I, p.92 Nr. 609a*)
val t = str2term "2*(3 - x/5)/3 - 4*(1 - x/3) - x/3 - 2*(x/2 - 1/4)/27 +5/54";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "(-255 + 112 * x) / 135" then () 
else error "rational.sml 6";

(*SRAM Schalk I, p.92 Nr. 610c*)
val t = str2term "((x- 1)/(x+1) + 1) / ((x- 1)/(x+1) - (x+1)/(x- 1)) - 2";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "(-3 + -1 * x) / 2" then () else error "rational.sml 7";

(*SRAM Schalk I, p.92 Nr. 476a*)
val t = str2term "(x^^^2/(1 - x^^^2) + 1)/(x/(1 - x) + 1) *\
		 \ (1 + x)";(*. a/b : c/d translated to a/b * d/c .*)
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
(*if term2str t' = "1 / 1" then () else error "rational.sml 8";3.6.03*)
if term2str t' = "1" then () else error "rational.sml 8";

(*............................vvv---TODO: sollte gehen mit poly_order *)
(*Schalk I, p.92 Nr. 472a*)
val t = str2term "((8*x^^^2 - 32*y^^^2)/(2*x + 4*y))/((4*x - 8*y)/(x + y))";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "x + y" then () else error "rational.sml p.92 Nr. 472a";

(*Schalk I, p.70 Nr. 480b; a/b : c/d translated to a/b * d/c*)
val t = str2term "((12*x*y/(9*x^^^2 - y^^^2))/\
		 \(1/(3*x - y)^^^2 - 1/(3*x + y)^^^2)) *\
		 \(1/(x - 5*y)^^^2 - 1/(x + 5*y)^^^2)/\
		 \(20*x*y/(x^^^2 - 25*y^^^2))";
(*... nicht simpl, zerlegt ...*)
val t = str2term "((12*x*y/(9*x^^^2 - y^^^2))/\
		 \(1/(3*x - y)^^^2 - 1/(3*x + y)^^^2))";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
"(-12 * (x * y ^^^ 3) + 108 * (x * (y * x ^^^ 2))) / (12 * (x * y))";
(*                             ~~~~~~~~~~ poly_order notwendig!*)
val t = str2term "(1/(x - 5*y)^^^2 - 1/(x + 5*y)^^^2)/\
		 \(20*x*y/(x^^^2 - 25*y^^^2))";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
"(-500 * (x * y ^^^ 3) /\n (x ^^^ 4 + (625 * y ^^^ 4 + -50 * (x ^^^ 2 * y ^^^ 2))) +\n 20 * (x * (y * x ^^^ 2)) /\n (x ^^^ 4 + (625 * y ^^^ 4 + -50 * (x ^^^ 2 * y ^^^ 2)))) /\n(20 * (x * y))";
trace_rewrite:=true;
trace_rewrite:=false;

"nonterm.SK6 ----- SK060904-2a non-termination of add_fraction_p_";
(*WN.2.6.03 from rlang.sml 56a 
val t = str2term "(a + b * x) / (a + -1 * (b * x)) + (-1 * a + b * x) / (a + b * x) = 4 * (a * b) / (a ^^^ 2 + -1 * b ^^^ 2)";
val NONE = rewrite_set_ thy false common_nominator_p t;

WN060831 nonterm.SK7 
val t = str2term "(a + b * x) / (a + -1 * (b * x)) + (-1 * a + b * x) / (a + b * x)";
val NONE = add_fraction_p_ thy t; 
*)


(* ------------------------------------------------------------------- *)
(*---------vvv------------ MG: ab 1.7.03 ----------------vvv-----------*)
(*                 Simplifier fuer beliebige Buchterme                 *) 
(* ------------------------------------------------------------------- *)
(*----------------------- norm_Rational_mg ----------------------------*)
(* ------------------------------------------------------------------- *)

"-------- numeral rationals --------------------------------------";
"-------- numeral rationals --------------------------------------";
"-------- numeral rationals --------------------------------------";

(*SRA Schalk I, p.40 Nr. 164b *)
val t = str2term "(47/6 - 76/9 + 13/4)/(35/12)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = "19 / 21" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 1";

(*SRA Schalk I, p.40 Nr. 166a *)
val t = str2term "((5/4)/(4+22/7) + 37/20)*(110/3 - 110/9 * 23/11)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = "45 / 2" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 2";


"-------- cancellation -------------------------------------------";
"-------- cancellation -------------------------------------------";
"-------- cancellation -------------------------------------------";

(* e190c Stefan K.*)
val t = str2term
"((1 + 9 * a ^^^ 2)*(1 + 3 * a))/((3 * a + 9 * a ^^^ 2)*(1 + 3 * a))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"(1 + 9 * a ^^^ 2) / (3 * a + 9 * a ^^^ 2)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 3";

(* e192b Stefan K.*)
val t = str2term
"((x ^^^ 2)*(7 * x + (-1) * y))/((y ^^^ 2)*(7 * x + (-1) * y))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"x ^^^ 2 / y ^^^ 2"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 4";

(*SRC Schalk I, p.66 Nr. 379c *)
val t = str2term 
"(a - b)/(b - a)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"-1"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 5";

(*SRC Schalk I, p.66 Nr. 380b *)
val t = str2term 
"15*(3*x+3)*(4*x+9)/(12*(2*x+7)*(5*x+5))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(27 + 12 * x) / (28 + 8 * x)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 6";

(*Schalk I, p.60 Nr. 215c *)
(* Falsches Ergebnis: rechnet lange und cancel_p kann nicht weiter krzen!!!*)
(* WN060831????MG1 
val t = str2term "(a+b)^^^4*(x - y)/((x - y)^^^3*(a+b)^^^2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(a ^^^ 4 * x + -1 * a ^^^ 4 * y + 4 * a ^^^ 3 * b * x + -4 * a ^^^ 3 * b * y + 6 * a ^^^ 2 * b ^^^ 2 * x + -6 * a ^^^ 2 * b ^^^ 2 * y + 4 * a * b ^^^ 3 * x + -4 * a * b ^^^ 3 * y + b ^^^ 4 * x + -1 * b ^^^ 4 * y) /(a ^^^ 2 * x ^^^ 3 + -3 * a ^^^ 2 * x ^^^ 2 * y + 3 * a ^^^ 2 * x * y ^^^ 2 + -1 * a ^^^ 2 * y ^^^ 3 + 2 * a * b * x ^^^ 3 + -6 * a * b * x ^^^ 2 * y + 6 * a * b * x * y ^^^ 2 + -2 * a * b * y ^^^ 3 + b ^^^ 2 * x ^^^ 3 + -3 * b ^^^ 2 * x ^^^ 2 * y + 3 * b ^^^ 2 * x * y ^^^ 2 + -1 * b ^^^ 2 * y ^^^ 3)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 7";
*)
(*val t = str2term 
"(a ^^^ 4 * x + -1 * a ^^^ 4 * y + 4 * a ^^^ 3 * b * x + -4 * a ^^^ 3 * b * y + 6 * a ^^^ 2 * b ^^^ 2 * x + -6 * a ^^^ 2 * b ^^^ 2 * y + 4 * a * b ^^^ 3 * x + -4 * a * b ^^^ 3 * y + b ^^^ 4 * x + -1 * b ^^^ 4 * y) /(a ^^^ 2 * x ^^^ 3 + -3 * a ^^^ 2 * x ^^^ 2 * y + 3 * a ^^^ 2 * x * y ^^^ 2 + -1 * a ^^^ 2 * y ^^^ 3 + 2 * a * b * x ^^^ 3 + -6 * a * b * x ^^^ 2 * y + 6 * a * b * x * y ^^^ 2 + -2 * a * b * y ^^^ 3 + b ^^^ 2 * x ^^^ 3 + -3 * b ^^^ 2 * x ^^^ 2 * y + 3 * b ^^^ 2 * x * y ^^^ 2 + -1 * b ^^^ 2 * y ^^^ 3)"
val SOME (t,_) = rewrite_set_ thy false cancel_p t;
term2str t;*)
(* uncaught exception nonexhaustive binding failure
   raised at: stdIn:93.1-93.51 *)

(*Schalk I, p.66 Nr. 381a *)
(* ACHTUNG: rechnet ca. 2 Minuten !!! *)
(* WN060831???MG2
val t = str2term "18*(a+b)^^^3*(a - b)^^^2/(72*(a - b)^^^3*(a+b)^^^2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(a + b) / (4 * a + -4 * b)"
then () else error "rational.sml.sml: diff.behav. in norm_Rational_mg 8";
*)

(*SRC Schalk I, p.66 Nr. 381b *)
val t = str2term 
"(4*x^^^2 - 20*x + 25)/(2*x - 5)^^^3";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"-1 / (5 + -2 * x)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 9";

(*SRC Schalk I, p.66 Nr. 381c *)
val t = str2term 
"(27*a^^^3+9*a^^^2+3*a+1)/(27*a^^^3+18*a^^^2+3*a)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(1 + 9 * a ^^^ 2) / (3 * a + 9 * a ^^^ 2)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 10";

(*SRC Schalk I, p.66 Nr. 383a *)
val t = str2term 
"(5*a^^^2 - 5*a*b)/(a - b)^^^2";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"5 * a / (a + -1 * b)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 11";

"-------- common denominator -------------------------------------";
"-------- common denominator -------------------------------------";
"-------- common denominator -------------------------------------";

(*SRA Schalk I, p.67 Nr. 403a *)
val t = str2term 
"4/x - 3/y - 1";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(-3 * x + 4 * y + -1 * x * y) / (x * y)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 12";

(*SRA Schalk I, p.67 Nr. 407b *)
val t = str2term 
"(2*a+3*b)/(b*c) + (3*c+a)/(a*c) - (2*a^^^2+3*b*c)/(a*b*c)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"4 / c"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 13";

(*SRA Schalk I, p.67 Nr. 410b *)
val t = str2term 
"1/(x+1) + 1/(x+2) - 2/(x+3)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(5 + 3 * x) / (6 + 11 * x + 6 * x ^^^ 2 + x ^^^ 3)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 14";

(*SRA Schalk I, p.67 Nr. 413b *)
val t = str2term 
"(1+x)/(1 - x) - (1 - x)/(1+x) + 2*x/(1 - x^^^2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"6 * x / (1 + -1 * x ^^^ 2)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 15";

(*SRA Schalk I, p.68 Nr. 414a *)
val t = str2term 
"(x + 2)/(x - 1) + (x - 3)/(x - 2) - (x + 1)/((x - 1)*(x - 2))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(-2 + -5 * x + 2 * x ^^^ 2) / (2 + -3 * x + x ^^^ 2)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 16";

(*SRA Schalk I, p.68 Nr. 423a *)
val t = str2term 
"(2*x+3*y)/x + (4*x^^^3 - x*y^^^2 - 3*y^^^3)/(x^^^3 - 2*x^^^2*y+x*y^^^2) - (5*x+6*y)/(x - y)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"1"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 17";

(*SRA Schalk I, p.68 Nr. 428b *)
val t = str2term 
"1/(a - b)^^^2 + 1/(a+b)^^^2 - 2/(a^^^2 - b^^^2) - 4*(b^^^2 - 1)/(a^^^2 - b^^^2)^^^2";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"4 / (a ^^^ 4 + -2 * a ^^^ 2 * b ^^^ 2 + b ^^^ 4)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 18";

(*SRA Schalk I, p.68 Nr. 430b *)
val t = str2term 
"a^^^2/(a - 3*b) - 108*a*b^^^3/((a+3*b)*(a^^^2 - 9*b^^^2)) - 9*b^^^2*(a - 3*b)/(a+3*b)^^^2";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"a + 3 * b"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 19";


(*SRA Schalk I, p.68 Nr. 432 *)
val t = str2term 
"(a^^^2+a*b)/(a^^^2 - b^^^2) - (b^^^2 - a*b)/(b^^^2 - a^^^2) + a^^^2*(a - b)/(a^^^3 - a^^^2*b) - 2*a*(a^^^2 - b^^^2)/(a^^^3 - a*b^^^2) - 2*b^^^2/(a^^^2 - b^^^2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"0"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 20";

(*Eigenes*)
val t = str2term 
"3*a/(a*b) + x/y";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(3 * y + b * x) / (b * y)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 21";


"-------- multiply and cancel ------------------------------------";
"-------- multiply and cancel ------------------------------------";
"-------- multiply and cancel ------------------------------------";

(*SRM Schalk I, p.68 Nr. 436a *)
val t = str2term 
"3*(x+y)/(15*(x - y)) * 25*(x - y)^^^2/(18*(x+y)^^^2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(5 * x + -5 * y) / (18 * x + 18 * y)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 22";

(*SRM.test Schalk I, p.68 Nr. 436b *)
(*WN060420???MG3 crashes with method 'simplify' in 
  IsacCore > Simplification > Rational Terms > Multiplication > No.2*)
val t = str2term "5*a*(a - b)^^^2*(a + b)^^^3/(7*b*(a - b)^^^3) * 7*b/(a + b)^^^3";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"5 * a / (a + -1 * b)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 23";

(*Schalk I, p.68 Nr. 437a *)
val t = str2term "(3*a - 4*b)/(4*c+3*e) * (3*a+4*b)/(9*a^^^2 - 16*b^^^2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
if (term2str t) = "1 / (4 * c + 3 * e)" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 24";

"----- S.K. corrected non-termination 060904";
val t = str2term "(3*a - 4*b) * (3*a+4*b)/((4*c+3*e)*(9*a^^^2 - 16*b^^^2))";
val SOME (t',_) = rewrite_set_ thy false make_polynomial t;
if term2str t' = "(9 * a ^^^ 2 + -16 * b ^^^ 2) /\n(36 * a ^^^ 2 * c + 27 * a ^^^ 2 * e + -64 * b ^^^ 2 * c +\n -48 * b ^^^ 2 * e)" then ()
else error "rational.sml.sml: S.K.8..corrected 060904-6";

"----- S.K. corrected non-termination of cancel_p_";
val t'' = str2term "(9 * a ^^^ 2 + -16 * b ^^^ 2) /\
\(36 * a^^^2 * c + (27 * a^^^2 * e + (-64 * b^^^2 * c + -48 * b^^^2 * e)))";
val SOME (t',_) = rewrite_set_ thy false cancel_p t'';
if term2str t' = "1 / (4 * c + 3 * e)" then ()
else error "rational.sml.sml: diff.behav. in cancel_p S.K.8";

(**)

(*Schalk I, p.68 Nr. 437b *)
(* nonterm.SK9 loops: cancel_p kann nicht weiter kuerzen!!! *)
val t'' = str2term "(a + b)/(x^^^2 - y^^^2) * ((x - y)^^^2/(a^^^2 - b^^^2))";
(* val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t'';
   *)

(*a casual output from above*)
val t = str2term 
"(a * x ^^^ 2 + -2 * a * x * y + a * y ^^^ 2 + b * x ^^^ 2 + -2 * b * x * y + b * y ^^^ 2) /(a ^^^ 2 * x ^^^ 2 + -1 * a ^^^ 2 * y ^^^ 2 + -1 * b ^^^ 2 * x ^^^ 2 + b ^^^ 2 * y ^^^ 2)"; 
(* WN060831 nonterm.SK10 
val SOME (t,_) = rewrite_set_ thy false cancel_p t;
term2str t;
*)

(*SRM Schalk I, p.68 Nr. 438a *)
val t = str2term 
"x*y/(x*y - y^^^2)*(x^^^2 - x*y)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"x ^^^ 2"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 24";

(*SRM Schalk I, p.68 Nr. 439b *)
val t = str2term 
"(4*x^^^2+4*x+1)*((x^^^2 - 2*x^^^3)/(4*x^^^2+2*x))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(x + -4 * x ^^^ 3) / 2"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 25";

(*SRM Schalk I, p.68 Nr. 440a *)
val t = str2term 
"(x^^^2 - 2*x)/(x^^^2 - 3*x) * (x - 3)^^^2/(x^^^2 - 4)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(-3 + x) / (2 + x)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 26";

"----- Schalk I, p.68 Nr. 440b SK11 works since 0707xx";
val t = str2term 
"(a^^^3 - 9*a)/(a^^^3*b - a*b^^^3)*(a^^^2*b+a*b^^^2)/(a+3)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational t;
if term2str t = "(-3 * a + a ^^^ 2) / (a + -1 * b)" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational 27";

"----- SK12 works since 0707xx";
val t = str2term "(a^^^3 - 9*a)*(a^^^2*b+a*b^^^2)/((a^^^3*b - a*b^^^3)*(a+3))";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; term2str t';
if term2str t' = "(-3 * a + a ^^^ 2) / (a + -1 * b)" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational 28";


"-------- common denominator and multiplication ------------------";
"-------- common denominator and multiplication ------------------";
"-------- common denominator and multiplication ------------------";

(*----------------------------------------------------------------------*)
(*--------- Gemeinsamer Nenner und Multiplikation von Bruechen ---------*)
(*----------------------------------------------------------------------*)


(*SRAM Schalk I, p.69 Nr. 441b *)
val t = str2term "(4*a/3 + 3*b^^^2/a^^^3 + b/(4*a))*(4*b/(3*a))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(36 * b ^^^ 3 + 3 * a ^^^ 2 * b ^^^ 2 + 16 * a ^^^ 4 * b) / (9 * a ^^^ 4)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 28";

(*SRAM Schalk I, p.69 Nr. 442b *)
val t = str2term "(15*a^^^2/x^^^3 - 5*b^^^4/x^^^2 + 25*c^^^2/x)*(x^^^3/(5*a*b^^^3*c^^^3)) + 1/c^^^3 * (b*x/a - 3*a/b^^^3)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"5 * x ^^^ 2 / (a * b ^^^ 3 * c)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 29";

(*SRAM Schalk I, p.69 Nr. 443b *)
val t = str2term "(a/2 + b/3)*(b/3 - a/2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(-9 * a ^^^ 2 + 4 * b ^^^ 2) / 36"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 30";

(*SRAM Schalk I, p.69 Nr. 445b *)
val t = str2term "(a^^^2/9 + 2*a/(3*b) + 4/b^^^2)*(a/3 - 2/b) + 8/b^^^3";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"a ^^^ 3 / 27"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 31";

(*SRAM Schalk I, p.69 Nr. 446b *)
val t = str2term "(x/(5*x + 4*y) - y/(5*x - 4*y) + 1)*(25*x^^^2 - 16*y^^^2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"30 * x ^^^ 2 + -9 * x * y + -20 * y ^^^ 2"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 32";

(*SRAM Schalk I, p.69 Nr. 449a *)(*Achtung: rechnet ca 8 Sekunden*)
val t = str2term 
"(2*x^^^2/(3*y)+x/y^^^2)*(4*x^^^4/(9*y^^^2)+x^^^2/y^^^4)*(2*x^^^2/(3*y) - x/y^^^2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(-81 * x ^^^ 4 + 16 * x ^^^ 8 * y ^^^ 4) / (81 * y ^^^ 8)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 33";

(*SRAM Schalk I, p.69 Nr. 450a *)
val t = str2term 
"(4*x/(3*y)+2*y/(3*x))^^^2 - (2*y/(3*x) - 2*x/y)*(2*y/(3*x)+2*x/y)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"(52 * x ^^^ 2 + 16 * y ^^^ 2) / (9 * y ^^^ 2)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 34";

"-------- double fractions ---------------------------------------";
"-------- double fractions ---------------------------------------";
"-------- double fractions ---------------------------------------";

(*SRD Schalk I, p.69 Nr. 454b *)
val t = str2term 
"((2 - x)/(2*a)) / (2*a/(x - 2))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"(-4 + 4 * x + -1 * x ^^^ 2) / (4 * a ^^^ 2)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 35";

(*SRD Schalk I, p.69 Nr. 455a *)
val t = str2term 
"(a^^^2 + 1)/(a^^^2 - 1) / ((a+1)/(a - 1))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"(1 + a ^^^ 2) / (1 + 2 * a + a ^^^ 2)" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 36";


"----- Schalk I, p.69 Nr. 455b";
val t = str2term "(x^^^2 - 4)/(y^^^2 - 9)/((2+x)/(3 - y))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
if term2str t = "(2 + -1 * x) / (3 + y)" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 37";

"----- SK060904-1a non-termination of cancel_p_ ?: worked before 0707xx";
val t = str2term "(x^^^2 - 4)*(3 - y)/((y^^^2 - 9)*(2+x))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational t;
if term2str t = "(2 + -1 * x) / (3 + y)" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 37b";

"----- ?: worked before 0707xx";
val t = str2term "(3 + -1 * y) / (-9 + y ^^^ 2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational t;
if term2str t = "-1 / (3 + y)" then ()
else error "rational.sml: -1 / (3 + y) norm_Rational";

(*SRD Schalk I, p.69 Nr. 456b *)
val t = str2term 
"(b^^^3 - b^^^2)/(b^^^2+b)/(b^^^2 - 1)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = "b / (1 + 2 * b + b ^^^ 2)" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 38";

(*SRD Schalk I, p.69 Nr. 457b *)
val t = str2term 
"(16*a^^^2 - 9*b^^^2)/(2*a+3*a*b) / ((4*a+3*b)/(4*a^^^2 - 9*a^^^2*b^^^2))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"8 * a ^^^ 2 + -6 * a * b + -12 * a ^^^ 2 * b + 9 * a * b ^^^ 2"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 39";

"----- Schalk I, p.69 Nr. 458b works since 0707";
val t = str2term 
"(2*a^^^2*x - a^^^2)/(a*x - b*x) / (b^^^2*(2*x - 1)/(x*(a - b)))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational t;
if term2str t = "a ^^^ 2 / b ^^^ 2" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 39b";

(*SRD Schalk I, p.69 Nr. 459b *)
val t = str2term "(a^^^2 - b^^^2)/(a*b) / (4*(a+b)^^^2/a)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational t;
if term2str t = "(a + -1 * b) / (4 * a * b + 4 * b ^^^ 2)" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 41";


(*Schalk I, p.69 Nr. 460b nonterm.SK
val t = str2term 
"(9*(x^^^2 - 8*x+16)/(4*(y^^^2 - 2*y+1)))/((3*x - 12)/(16*y - 16))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
if term2str t = 
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 42";

val t = str2term 
"9*(x^^^2 - 8*x+16)*(16*y - 16)/(4*(y^^^2 - 2*y+1)*(3*x - 12))";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t;
... non terminating.
val SOME (t',_) = rewrite_set_ thy false make_polynomial t;
"(-2304 + 1152 * x + 2304 * y + -144 * x ^^^ 2 + -1152 * x * y + 144 * x ^^^ 2 * y) /(-48 + 12 * x + 96 * y + -24 * x * y + -48 * y ^^^ 2 + 12 * x * y ^^^ 2)";
val SOME (t,_) = rewrite_set_ thy false cancel_p t';
... non terminating.*)

(*SRD Schalk I, p.70 Nr. 472a *)
val t = str2term "((8*x^^^2 - 32*y^^^2)/(2*x + 4*y))/\
		 \((4*x - 8*y)/(x + y))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"x + y"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 43";


(*----------------------------------------------------------------------*)
(*---------------------- Einfache Dppelbrche --------------------------*)
(*----------------------------------------------------------------------*)

(*SRD Schalk I, p.69 Nr. 461a *)
val t = str2term 
"(2/(x+3) + 2/(x - 3)) / (8*x/(x^^^2 - 9))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"1 / 2"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 44";

(*SRD Schalk I, p.69 Nr. 464b *)
val t = str2term 
"(a - a/(a - 2)) / (a + a/(a - 2))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"(3 + -1 * a) / (1 + -1 * a)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 45";

(*SRD Schalk I, p.69 Nr. 465b *)
val t = str2term 
"((x+3*y)/9 + (4*y^^^2 - 9*z^^^2)/(16*x)) /(x/9+y/6+z/4)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"(4 * x + 6 * y + -9 * z) / (4 * x)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 46";

(*SRD Schalk I, p.69 Nr. 466b *)
val t = str2term 
"((1 - 7*(x - 2)/(x^^^2 - 4)) / (6/(x+2))) / (3/(x+5)+30/(x^^^2 - 25))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"(25 + -10 * x + x ^^^ 2) / 18"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 47";

(*SRD Schalk I, p.70 Nr. 469 *)
val t = str2term 
"3*b^^^2/(4*a^^^2 - 8*a*b + 4*b^^^2)/(a/(a^^^2*b - b^^^3) + (a - b)/(4*a*b^^^2+4*b^^^3) - 1/(4*b^^^2))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 
"3 * b ^^^ 3 / (2 * a + -2 * b)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 48";

(*----------------------------------------------------------------------*)
(*---------------------- Mehrfache Dppelbrueche ------------------------*)
(*----------------------------------------------------------------------*)

(*SRD.test Schalk I, p.70 Nr. 476b *) (* Rechenzeit: 10 sec *)
(*WN060419 crashes with method 'simplify' ????SK*)
val t = str2term 
"((a^^^2 - b^^^2)/(2*a*b)+2*a*b/(a^^^2 - b^^^2))/((a^^^2+b^^^2)/(2*a*b)+1) / ((a^^^2+b^^^2)^^^2/(a+b)^^^2)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational t;
if term2str t = "1 / (a ^^^ 2 + -1 * b ^^^ 2)" then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 49";

"----- Schalk I, p.70 Nr. 477a";
(* MG Achtung: terme explodieren; Bsp zu komplex; 
   L???ung sollte (ziemlich grosser) Faktorisierter Ausdruck sein 
val t = str2term "b*y/(b - 2*y)/((b^^^2 - y^^^2)/(b+2*y)) /\
		 \(b^^^2*y+b*y^^^2)*(a+x)^^^2/((b^^^2 - 4*y^^^2)*(a+2*x)^^^2)";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t;


val t = str2term "b*y*(b+2*y)*(b^^^2 - 4*y^^^2)*(a+2*x)^^^2 / \
		 \((b - 2*y)*(b^^^2 - y^^^2)*(b^^^2*y+b*y^^^2)*(a+x)^^^2)";
val SOME (t,_) = rewrite_set_ thy false make_polynomial t;
????SK ???MG*)


"----- Schalk I, p.70 Nr. 478b ----- Rechenzeit: 5 sec";
val t = str2term "(a - (a*b+b^^^2)/(a+b))/(b+(a - b)/(1+(a+b)/(a - b))) / \
		 \((a - a^^^2/(a+b))/(a+(a*b)/(a - b)))";
val SOME (t',_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
if term2str t' = 
"(2 * a ^^^ 3 + 2 * a ^^^ 2 * b) / (a ^^^ 2 * b + b ^^^ 3)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 51";

(* TODO.new_c:WN050820 STOP_REW_SUB introduced gave ...
if term2str t' = "(a ^^^ 4 + -1 * a ^^^ 2 * b ^^^ 2) /\n(a * b * (b + (a * (a + -1 * b) + -1 * b * (a + -1 * b)) / (2 * a)) *\n (a + -1 * b))" then ()
else error "rational.sml: works again";
re-outcommented with TODO.new_c: cvs before 071227, 11:50*)



(*Schalk I, p.70 Nr. 480a *)
(* Achtung: rechnet ewig; cancel_p kann nicht krzen: WN060831 nonterm.SK00
val t = str2term 
"(1/x+1/y+1/z)/(1/x - 1/y - 1/z) / (2*x^^^2/(x^^^2 - z^^^2)/(x/(x+z)+x/(x - z)))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) = 

then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 52";

(*MG Berechne Zwischenergebnisse: WN060831 nonterm.SK00*)
val t = str2term 
"(1/x+1/y+1/z)/(1/x - 1/y - 1/z)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
"(x ^^^ 2 * y ^^^ 2 * z + x ^^^ 2 * y * z ^^^ 2 + x * y ^^^ 2 * z ^^^ 2) /
(-1 * x ^^^ 2 * y ^^^ 2 * z + -1 * x ^^^ 2 * y * z ^^^ 2 + x * y ^^^ 2 * z ^^^ 2)";
val t = str2term 
"2*x^^^2/(x^^^2 - z^^^2)/(x/(x+z)+x/(x - z))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
"1"

(* SK 1. Ausdruck kann nicht weiter gekrzt werden; cancel_p !!!*)
###  rls: cancel_p on: 
(x ^^^ 2 * (y ^^^ 2 * z) + x ^^^ 2 * (y * z ^^^ 2) + x * (y ^^^ 2 * z ^^^ 2)) /
(-1 * (x ^^^ 2 * (y ^^^ 2 * z)) + -1 * (x ^^^ 2 * (y * z ^^^ 2)) + x * (y ^^^ 2 * z ^^^ 2))
GC #3.61.81.101.197.17503:   (0 ms)
*** RATIONALS_DIRECT_CANCEL_EXCEPTION: Invalid fraction

val t = str2term 
"(x^^^2 * (y^^^2 * z) + x^^^2 * (y * z^^^2) + x * (y^^^2 * z^^^2)) / (-1 * (x^^^2 * (y^^^2 * z)) + -1 * (x^^^2 * (y * z^^^2)) + x * (y^^^2 * z^^^2))";
val SOME (t,_) = rewrite_set_ thy false cancel_p t;
term2str t;
(*uncaught exception nonexhaustive binding failure*)

(* Das kann er aber krzen !!????: *)
val t = str2term 
"(x^^^2 * (y^^^2 * z) +  x * (y^^^2 * z^^^2)) / (-1 * (x^^^2 * (y * z^^^2)) + x * (y^^^2 * z^^^2))";
val SOME (t,_) = rewrite_set_ thy false cancel_p t;
term2str t;
"(-1 * (y * x) + -1 * (z * y)) / (1 * (z * x) + -1 * (z * y))";
*)






(*--------------------------------------------------------------------*)
(*----------------------- Problem-Beispiele --------------------------*)
(*--------------------------------------------------------------------*)

(*Schalk I, p.60 Nr. 215d *)
(* Achtung: rechnet ewig ...
val t = str2term "(a-b)^^^3 * (x+y)^^^4 / ((x+y)^^^2 * (a-b)^^^5)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t; noterm.SK
*)

(* Kein Wunder, denn Z???ler und Nenner extra als Polynom dargestellt ergibt:*)
(*
val t = str2term "(a-b)^^^3 * (x+y)^^^4";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
"a^^^3 * x^^^4 + 4 * a^^^3 * x^^^3 * y +\n6 * a^^^3 * x^^^2 * y^^^2 +\n4 * a^^^3 * x * y^^^3 +\na^^^3 * y^^^4 +\n-3 * a^^^2 * b * x^^^4 +\n-12 * a^^^2 * b * x^^^3 * y +\n-18 * a^^^2 * b * x^^^2 * y^^^2 +\n-12 * a^^^2 * b * x * y^^^3 +\n-3 * a^^^2 * b * y^^^4 +\n3 * a * b^^^2 * x^^^4 +\n12 * a * b^^^2 * x^^^3 * y +\n18 * a * b^^^2 * x^^^2 * y^^^2 +\n12 * a * b^^^2 * x * y^^^3 +\n3 * a * b^^^2 * y^^^4 +\n-1 * b^^^3 * x^^^4 +\n-4 * b^^^3 * x^^^3 * y +\n-6 * b^^^3 * x^^^2 * y^^^2 +\n-4 * b^^^3 * x * y^^^3 +\n-1 * b^^^3 * y^^^4";
val t = str2term "((x+y)^^^2 * (a-b)^^^5)";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
"a^^^5 * x^^^2 + 2 * a^^^5 * x * y + a^^^5 * y^^^2 +\n-5 * a^^^4 * b * x^^^2 +\n-10 * a^^^4 * b * x * y +\n-5 * a^^^4 * b * y^^^2 +\n10 * a^^^3 * b^^^2 * x^^^2 +\n20 * a^^^3 * b^^^2 * x * y +\n10 * a^^^3 * b^^^2 * y^^^2 +\n-10 * a^^^2 * b^^^3 * x^^^2 +\n-20 * a^^^2 * b^^^3 * x * y +\n-10 * a^^^2 * b^^^3 * y^^^2 +\n5 * a * b^^^4 * x^^^2 +\n10 * a * b^^^4 * x * y +\n5 * a * b^^^4 * y^^^2 +\n-1 * b^^^5 * x^^^2 +\n-2 * b^^^5 * x * y +\n-1 * b^^^5 * y^^^2";
*)
(*anscheinend macht dem Rechner das Krzen diese Bruches keinen Spass mehr ...*)

(*--------------------------------------------------------------------*)
(*Schalk I, p.70 Nr. 480b 
val t = str2term "((12*x*y/(9*x^^^2 - y^^^2))/\
		 \(1/(3*x - y)^^^2 - 1/(3*x + y)^^^2)) *\
		 \(1/(x - 5*y)^^^2 - 1/(x + 5*y)^^^2)/\
		 \(20*x*y/(x^^^2 - 25*y^^^2))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
SK.nonterm
Kann nicht weiter vereinfacht werden !!!!?? *)

(*--------------------------------------------------------------------*)
"---- MGs test set";
val t = str2term " (1 + x^^^5) / (y + x) + x^^^3 / x ";
val SOME (t,_) = rewrite_set_ thy false common_nominator_p t;
if term2str t = "(1 + x ^^^ 3 + x ^^^ 5 + y * x ^^^ 2) / (x + y)" then()
else error "";

(*--------------------------------------------------------------------*)
(* cancel_p liefert nicht immer Polynomnormalform (2): WN060831???SK3b
   ---> Sortierung FALSCH !!  *)
val t = str2term "b^^^3 * a^^^5/a ";
val SOME (t,_) = rewrite_set_ thy false cancel_p t;
term2str t;
"1 * (a^^^4 * b^^^3) / 1"; (*OK*)

val t = str2term "b^^^3 * a^^^5/b ";
val SOME (t,_) = rewrite_set_ thy false cancel_p t;
term2str t;
"1 * (b^^^2 * a^^^5) / 1"; (*cancel_p sortiert hier falsch um!*)

(* Problem liegt NICHT bei ord_make_polynomial! (siehe folgende Bsple) *)
(*
val x = str2term "x"; val bdv = str2term "bdv";
val t1 = str2term "b^^^2 * a^^^5";
val t2 = str2term "a^^^5 * b^^^2 ";
ord_make_polynomial false Rational.thy [(x,bdv)] (t1,t2); (*false*)
*)
(* ==> "b^^^2 * a^^^5" > "a^^^5 * b^^^2 " ... OK!*)

(*--------------------------------------------------------------------*)
(* cancel_p liefert nicht immer Polynomnormalform (2): WN060831???SK3c
   ---> erzeugt berflssige "1 * ..."
   
val t = str2term "-1 / (3 + y)";
(*~~         *)
val SOME (t,_) = rewrite_set_ thy false cancel_p t;
term2str t;
"-1 / (3 + 1 * y)";
(********* Das ist das PROBLEM !!!!!!!??? *******************)
(* -1 im Z???ler der Angabe verursacht das Problem !*)
*)

(* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - *)
"----- MGs test set";
val t = str2term "(a^^^2 + -1)/(a+1)";
val SOME (t',_) = rewrite_set_ thy false cancel_p t;
if term2str t' = "(-1 + a) / 1" then ()
else error "rational.sml MG tests 3d";

"----- NOT TERMINATING ?: worked before 0707xx";
val t = str2term "(a^^^2 - 1)*(b + 1) / ((b^^^2 - 1)*(a+1))";
val SOME (t'',_) = rewrite_set_ thy false norm_Rational t;
if term2str t'' = "(1 + -1 * a) / (1 + -1 * b)" then ()
else error "rational.sml MG tests 3e";

"----- corrected SK060905";
val t = str2term "(4*x^^^2 - 20*x + 25)/(2*x - 5)^^^3";
val SOME (t',_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
if term2str t' = "-1 / (5 + -2 * x)" then ()
else error "rational.sml corrected SK060905";


"--------------------------------------------------------------------";
"----------------------- Muster-Beispiele fuer DA -------------------";
"--------------------------------------------------------------------";

(*SRAM Schalk I, p.69 Nr. 442b --- abgewandelt*)
val t = str2term 
"(15*a^^^4/(a*x^^^3) - 5*a*((b^^^4 - 5*c^^^2*x)/x^^^2))*(x^^^3/(5*a*b^^^3*c^^^3)) + a/c^^^3 * (x*(b/a) - 3*b*(a/b^^^4))";
val SOME (t,_) = rewrite_set_ thy false norm_Rational(*_mg*) t;
term2str t;
if (term2str t) =
"5 * x ^^^ 2 / (b ^^^ 3 * c)"
then ()
else error "rational.sml.sml: diff.behav. in norm_Rational_mg 53";

"-------- me Schalk I No.186 -------------------------------------";
"-------- me Schalk I No.186 -------------------------------------";
"-------- me Schalk I No.186 -------------------------------------";
val fmz = ["TERM ((14 * x * y) / ( x * y ))",
	   "normalform N"];
val (dI',pI',mI') =
  ("Rational",["rational","simplification"],
   ["simplification","of_rationals"]);
val p = e_pos'; val c = []; 
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;(*++ for explicit script*)
val (p,_,f,nxt,_,pt) = me nxt p c pt; f2str f;(*++ for explicit script*)
case (f2str f, nxt) of
    ("14", ("End_Proof'", _)) => ()
  | _ => error "rational.sml diff.behav. in me Schalk I No.186";


"-------- interSteps ..Simp_Rat_Double_No-1.xml ------------------";
"-------- interSteps ..Simp_Rat_Double_No-1.xml ------------------";
"-------- interSteps ..Simp_Rat_Double_No-1.xml ------------------";
states:=[];
CalcTree
[(["TERM (((2 - x)/(2*a)) / (2*a/(x - 2)))", "normalform N"], 
  ("Rational",["rational","simplification"],
  ["simplification","of_rationals"]))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; show_pt pt;

interSteps 1 ([1],Res);
val ((pt,p),_) = get_calc 1; show_pt pt;


"-------- interSteps ..Simp_Rat_Cancel_No-1.xml ------------------";
"-------- interSteps ..Simp_Rat_Cancel_No-1.xml ------------------";
"-------- interSteps ..Simp_Rat_Cancel_No-1.xml ------------------";
states:=[];
CalcTree
[(["TERM ((a^2 + -1*b^2) / (a^2 + -2*a*b + b^2))", "normalform N"], 
  ("Rational",["rational","simplification"],
  ["simplification","of_rationals"]))];
Iterator 1;
moveActiveRoot 1;
autoCalculate 1 CompleteCalc;
val ((pt,p),_) = get_calc 1; show_pt pt;
(*with explicit script done already... and removed [1,..] at below...
interSteps 1 ([1],Res);
val ((pt,p),_) = get_calc 1; show_pt pt;
*)
interSteps 1 ([2],Res);
val ((pt,p),_) = get_calc 1; show_pt pt;

interSteps 1 ([2,1],Res);
val ((pt,p),_) = get_calc 1; show_pt pt;
val newnds = children (get_nd pt [2,1]) (*see "fun detailrls"*);
(*if length newnds = 12 then () WN060905*)
if length newnds = 13 then ()
else error "rational.sml: interSteps cancel_p rev_rew_p";

val p = ([2,1,9],Res);
getTactic 1 p;
val (_, tac, _) = pt_extract (pt, p);
(*case tac of SOME (Rewrite ("sym_real_plus_binom_times1", _)) => ()
WN060905*)
case tac of SOME (Rewrite ("sym_real_add_mult_distrib2", _)) => ()
| _ => error "rational.sml: getTactic, sym_real_plus_binom_times1";


"-------- investigate rulesets for cancel_p ----------------------";
"-------- investigate rulesets for cancel_p ----------------------";
"-------- investigate rulesets for cancel_p ----------------------";
val thy = Rational.thy;
"---------------- (a^^^2 + -1*b^^^2) / (a^^^2 + -2*a*b + b^^^2)";
val t = str2term "(a^^^2 + -1*b^^^2) / (a^^^2 + -2*a*b + b^^^2)";
val tt = str2term "(1 * a + 1 * b) * (1 * a + -1 * b)"(*numerator only*);
"----- with rewrite_set_";
val SOME (tt',asm) = rewrite_set_ thy false make_polynomial tt;
term2str tt'= "a ^^^ 2 + -1 * b ^^^ 2" (*true*);
val tt = str2term "((1 * a + -1 * b) * (1 * a + -1 * b))"(*denominator only*);
val SOME (tt',asm) = rewrite_set_ thy false make_polynomial tt;
term2str tt' = "a ^^^ 2 + -2 * a * b + b ^^^ 2" (*true*);

"----- with make_deriv";
val SOME (tt, _) = factout_p_ Isac.thy t; term2str tt =
"(1 * a + 1 * b) * (1 * a + -1 * b) / ((1 * a + -1 * b) * (1 * a + -1 * b))";
(*
"--- with ruleset as before 060829";
val {rules, rew_ord=(_,ro),...} =
    rep_rls (assoc_rls "make_polynomial");
val der = make_deriv thy Atools_erls rules ro NONE tt;
print_depth 99; map (term2str o #1) der; print_depth 3;
print_depth 99; map (rule2str o #2) der; print_depth 3;
... did not terminate"*)
"--- with simpler ruleset";
val {rules, rew_ord=(_,ro),...} =
    rep_rls (assoc_rls "rev_rew_p");
val der = make_deriv thy Atools_erls rules ro NONE tt;
print_depth 99; writeln (deriv2str der); print_depth 3;

print_depth 99; map (term2str o #1) der; print_depth 3;
"...,(-1 * b ^^^ 2 + a ^^^ 2) / (-2 * (a * b) + a ^^^ 2 + (-1 * b) ^^^ 2) ]";
print_depth 99; map (rule2str o #2) der; print_depth 3;
print_depth 99; map (term2str o #1 o #3) der; print_depth 3;

val der = make_deriv thy Atools_erls rules ro NONE 
		     (str2term "(1 * a + 1 * b) * (1 * a + -1 * b)");
print_depth 99; writeln (deriv2str der); print_depth 3;

val {rules, rew_ord=(_,ro),...} =
    rep_rls (assoc_rls "rev_rew_p");
val der = make_deriv thy Atools_erls rules ro NONE 
		     (str2term "(1 * a + -1 * b) * (1 * a + -1 * b)");
print_depth 99; writeln (deriv2str der); print_depth 3;
print_depth 99; map (term2str o #1) der; print_depth 3;
(*WN060829 ...postponed*)


"-------- investigate format of factout_ and factout_p_ ----------";
"-------- investigate format of factout_ and factout_p_ ----------";
"-------- investigate format of factout_ and factout_p_ ----------";
val {rules, rew_ord = (_,ro),...} = rep_rls (assoc_rls "make_polynomial");
val (thy, eval_rls) = (Rational.thy, Atools_erls)(*see 'fun init_state'*);
val Rrls {scr = Rfuns {init_state,...},...} = assoc_rls "cancel_p";

"----- see  Rational.ML, local cancel_p, fun init_state";
val t = str2term "(a^^^2 + (-1)*b^^^2) / (a^^^2 + (-2)*a*b + b^^^2)";
val SOME (t',_) = factout_p_ thy t; term2str t';
(*
val rtas = reverse_deriv thy eval_rls rules ro NONE t';
writeln(trtas2str rst);
*)


"----- see  Rational.ML, local cancel_p, fun init_state";
val t = str2term "a^^^2 / a";
val SOME (t',_) = factout_p_ thy t; 
term2str t' = "a * a / (1 * a)" (*true*); 
(*... can be canceled with
real_mult_div_cancel2 ?k ~= 0 ==> ?m * ?k / (?n * ?k) = ?m / ?n"*)
(* sml/ME/rewtools.sml:
val rtas = reverse_deriv thy Atools_erls rules ro NONE t';
writeln (deri2str rtas);
*)



"-------- SK 060904 ----------------------------------------------";
"-------- SK 060904 ----------------------------------------------";
"-------- SK 060904 ----------------------------------------------";
"----- order on polynomials -- input + output";
val thy = Isac.thy;
val t = str2term "(a + -1 * b) / (-1 * a + b)";
val SOME (t', _) = factout_p_ thy t; term2str t';
val SOME (t', _) = cancel_p_ thy t; term2str t';

val t = str2term "a*b*c*d / (d*e*f*g)";
val SOME (t', _) = cancel_p_ thy t; term2str t';

val t = str2term "a*(b*(c*d)) / (b*(e*(f*g)))";
val SOME (t', _) = cancel_p_ thy t; term2str t';
(*???order.SK  ???*)

"----- SK060904-1a non-termination of cancel_p_ ? worked before 0707xx";
val t = str2term "(x^^^2 - 4)*(3 - y) / ((y^^^2 - 9)*(2+x))";
val SOME (t',_) = rewrite_set_ thy false norm_Rational t; 
if term2str t' = "(2 + -1 * x) / (3 + y)" then ()
else error "rational.sml SK060904-1a worked since 0707xx";

"----- SK060904-1b non-termination of cancel_p_ ... worked before 0707xx";
val t = str2term "(9 * a ^^^ 2 + -16 * b ^^^ 2) /\
\(36 * a^^^2 * c + (27 * a^^^2 * e + (-64 * b^^^2 * c + -48 * b^^^2 * e)))";
val SOME (t',_) = cancel_p_ thy t; 
if term2str t' = "1 / (4 * c + 3 * e)" then ()
else error "rational.sml SK060904-1b";


"----- SK060904-2a non-termination of add_fraction_p_";
val t = str2term " (a + b * x) / (a + -1 * (b * x)) +  \
		 \ (-1 * a + b * x) / (a + b * x)      ";
(* nonterm.SK
val SOME (t',_) = rewrite_set_ thy false common_nominator_p t;

common_nominator_p_ thy t;
" (a + b * x)*(a + b * x) / ((a + -1 * (b * x))*(a + -1 * (b * x))) +  \
\ (-1 * a + b * x)*(a + -1 * (b * x)) / ((a + b * x)*(-1 * a + b * x)) ";

add_fraction_p_ thy t; 
" ((a + b * x)*(a + b * x)  +  (-1 * a + b * x)*(a + -1 * (b * x))) /\
\ ((a + b * x)*(-1 * a + b * x))                                     ";
*)


"-------- how to stepwise construct Scripts ----------------------";
"-------- how to stepwise construct Scripts ----------------------";
"-------- how to stepwise construct Scripts ----------------------";
lse error "rational.sml SK060904-1a worked since 0707xx";

"----- SK060904-1b non-termination of cancel_p_ ... worked before 0707xx";
val t = str2term "(9 * a ^^^ 2 + -16 * b ^^^ 2) /\
\(36 * a^^^2 * c + (27 * a^^^2 * e + (-64 * b^^^2 * c + -48 * b^^^2 * e)))";
val SOME (t',_) = cancel_p_ thy t; 
if term2str t' = "1 / (4 * c + 3 * e)" then ()
else error "rational.sml SK060904-1b";


"----- SK060904-2a non-termination of add_fraction_p_";
val t = str2term " (a + b * x) / (a + -1 * (b * x)) +  \
		 \ (-1 * a + b * x) / (a + b * x)      ";
(* nonterm.SK
val SOME (t',_) = rewrite_set_ thy false common_nominator_p t;

common_nominator_p_ thy t;
" (a + b * x)*(a + b * x) / ((a + -1 * (b * x))*(a + -1 * (b * x))) +  \
\ (-1 * a + b * x)*(a + -1 * (b * x)) / ((a + b * x)*(-1 * a + b * x)) ";

add_fraction_p_ thy t; 
" ((a + b * x)*(a + b * x)  +  (-1 * a + b * x)*(a + -1 * (b * x))) /\
\ ((a + b * x)*(-1 * a + b * x))                                     ";
*)


"-------- how to stepwise construct Scripts ----------------------";
"-------- how to stepwise construct Scripts ----------------------";
"-------- how to stepwise construct Scripts ----------------------";
lse error "rational.sml SK060904-1a worked since 0707xx";

"----- SK060904-1b non-termination of cancel_p_ ... worked before 0707xx";
val t = str2term "(9 * a ^^^ 2 + -16 * b ^^^ 2) /\
\(36 * a^^^2 * c + (27 * a^^^2 * e + (-64 * b^^^2 * c + -48 * b^^^2 * e)))";
val SOME (t',_) = cancel_p_ thy t; 
if term2str t' = "1 / (4 * c + 3 * e)" then ()
else error "rational.sml SK060904-1b";


"----- SK060904-2a non-termination of add_fraction_p_";
val t = str2term " (a + b * x) / (a + -1 * (b * x)) +  \
		 \ (-1 * a + b * x) / (a + b * x)      ";
(* nonterm.SK
val SOME (t',_) = rewrite_set_ thy false common_nominator_p t;

common_nominator_p_ thy t;
" (a + b * x)*(a + b * x) / ((a + -1 * (b * x))*(a + -1 * (b * x))) +  \
\ (-1 * a + b * x)*(a + -1 * (b * x)) / ((a + b * x)*(-1 * a + b * x)) ";

add_fraction_p_ thy t; 
" ((a + b * x)*(a + b * x)  +  (-1 * a + b * x)*(a + -1 * (b * x))) /\
\ ((a + b * x)*(-1 * a + b * x))                                     ";
*)


"-------- how to stepwise construct Scripts ----------------------";
"-------- how to stepwise construct Scripts ----------------------";
"-------- how to stepwise construct Scripts ----------------------";
val thy = (theory "Rational");
val -------------------------------------------------- = "00000";
(*no trailing _*)
val p1 = parse thy (
"Script SimplifyScript (t_t::real) =                             " ^
"  (Rewrite_Set discard_minus False                   " ^
"   t_t)");

(*required (): (Rewrite_Set discard_minus False)*)
val p2 = parse thy (
"Script SimplifyScript (t_t::real) =                             " ^
"  (Rewrite_Set discard_minus False                   " ^
"   t_t)");

val p3 = parse thy (
"Script SimplifyScript (t_t::real) =                             " ^
"  ((Rewrite_Set discard_minus False)                   " ^
"   t_t)");

val p4 = parse thy (
"Script SimplifyScript (t_t::real) =                             " ^
"  ((Rewrite_Set discard_minus False)                   " ^
"   t_t)");

val p5 = parse thy (
"Script SimplifyScript (t_t::real) =                             " ^
"  ((Try (Rewrite_Set discard_minus False)                   " ^
"    Try (Rewrite_Set discard_parentheses False))               " ^
"   t_t)");

val --------------------------------------------------+ = "11111";
val p6 = parse thy (
"Script SimplifyScript (t_t::real) =                             " ^
"  ((Try (Rewrite_Set discard_minus False) @@                   " ^
"    Try (Rewrite_Set rat_mult_poly False) @@                    " ^
"    Try (Rewrite_Set make_rat_poly_with_parentheses False) @@   " ^
"    Try (Rewrite_Set cancel_p_rls False) @@                     " ^
"    (Repeat                                                     " ^
"     ((Try (Rewrite_Set common_nominator_p_rls False) @@        " ^
"       Try (Rewrite_Set rat_mult_div_pow False) @@              " ^
"       Try (Rewrite_Set make_rat_poly_with_parentheses False) @@" ^
"       Try (Rewrite_Set cancel_p_rls False) @@                  " ^
"       Try (Rewrite_Set rat_reduce_1 False)))) @@               " ^
"    Try (Rewrite_Set discard_parentheses False))               " ^
"   t_t)"
);
val --------------------------------------------------++ = "22222";
