(* Title:  test calculation of values for function constants
   Author: Walther Neuper 2000
   (c) copyright due to lincense terms.

12345678901234567890123456789012345678901234567890123456789012345678901234567890
        10        20        30        40        50        60        70        80
*)

"--------------------------------------------------------";
"table of contents --------------------------------------";
"--------------------------------------------------------";
"----------- check return value of get_calculation_  ----";
"----------- fun calculate_ -----------------------------";
"----------- fun calculate_ -----------------------------";
"----------- calculate from script ----------------------";
"----------- calculate check test-root-equ --------------";
"----------- check calculate bottom up ------------------";
" ================= calculate.sml:10.8.02 2002:///->/ ======== ";
" ================= calculate.sml: calculate_ 2002 =================== ";
"----------- get_pair with 3 args -----------------------";
"----------- calculate (2 * x is_const) -----------------";
"--------------------------------------------------------";
"--------------------------------------------------------";
"--------------------------------------------------------";


"----------- check return value of get_calculation_  ----";
"----------- check return value of get_calculation_  ----";
"----------- check return value of get_calculation_  ----";
val thy = theory "Poly";
val cal = snd (assoc1 (! calclist', "is_polyexp"));
val t = @{term "(x / x) is_polyexp"};
val SOME (thmID, thm) = get_calculation_ thy cal t;
(HOLogic.dest_Trueprop (prop_of thm); writeln "all thms wrapped by Trueprop")
handle TERM _ => 
       error "calculate.sml: get_calculation_ must return Trueprop";

"----------- fun calculate_ -----------------------------";
"----------- fun calculate_ -----------------------------";
"----------- fun calculate_ -----------------------------";
val thy = theory "Test";
"===== test 1";
val t = (term_of o the o (parse thy)) "1+2";
val SOME (thmID,thm) = get_calculation_ thy (the(assoc(calclist,"PLUS"))) t;
term2str (prop_of thm) = "1 + 2 = 3";

"===== test 2";
val t = (term_of o the o (parse thy)) "((1+2)*4/3)^^^2";
val SOME (thmID,thm) = get_calculation_ thy (the(assoc(calclist,"PLUS"))) t;
val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
term2str t = "(3 * 4 / 3) ^^^ 2";

"===== test 3b -- 2 contiued";
val SOME (thmID,thm) = get_calculation_ thy (the(assoc(calclist,"TIMES"))) t;
val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
term2str t;
(*val it = "(#12 // #3) ^^^ #2" : string*)

"===== test 4";
val SOME (thmID,thm) = get_calculation_ thy(the(assoc(calclist,"DIVIDE")))t;
val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
term2str t;
(*it = "#4 ^^^ #2" : string*)

"===== test 5";
val SOME (thmID,thm) = get_calculation_ thy(the(assoc(calclist,"POWER")))t;
val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
term2str t;
(*val it = "#16" : string*)
if it <> "16" then error "calculate.sml: new behaviour in calculate_"
else ();

"----------- calculate from script ----------------------";
"----------- calculate from script ----------------------";
"----------- calculate from script ----------------------";
store_pbt
 (prep_pbt (theory "Test") "pbl_ttest" [] e_pblID
 (["test"],
  [],
  e_rls, NONE, []));
store_pbt
 (prep_pbt (theory "Test") "pbl_ttest_calc" [] e_pblID
 (["calculate","test"],
  [("#Given" ,["realTestGiven t_t"]),
   ("#Find"  ,["realTestFind s_s"])
   ],
  e_rls, NONE, [["Test","test_calculate"]]));

store_met
 (prep_met (theory "Test") "met_testcal" [] e_metID
 (["Test","test_calculate"]:metID,
  [("#Given" ,["realTestGiven t_t"]),
   ("#Find"  ,["realTestFind s_s"])
   ],
  {rew_ord'="sqrt_right",rls'=tval_rls,srls=e_rls,prls=e_rls,
   calc=[("PLUS"    ,("op +"        ,eval_binop "#add_")),
	 ("TIMES"   ,("Groups.times_class.times"        ,eval_binop "#mult_")),
	 ("DIVIDE" ,("HOL.divide"  ,eval_cancel "#divide_")),
	 ("POWER"  ,("Atools.pow"  ,eval_binop "#power_"))],
   crls=tval_rls, nrls=e_rls(*,
   asm_rls=[],asm_thm=[]*)},
  "Script STest_simplify (t_t::real) =          \
  \(Repeat                                        \
  \ ((Try (Repeat (Calculate PLUS))) @@   \
  \  (Try (Repeat (Calculate TIMES))) @@  \
  \  (Try (Repeat (Calculate DIVIDE))) @@ \
  \  (Try (Repeat (Calculate POWER))))) t_t"
   ));

val fmz = ["realTestGiven (((1+2)*4/3)^^^2)","realTestFind s"];
val (dI',pI',mI') =
  ("Test",["calculate","test"],["Test","test_calculate"]);


(*===== inhibit exn ?===========================================================
GOON after rewriting works

val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt =("Add_Given",Add_Given "realTestGiven (((#1 + #2) * #4 // #3) ^^^#2)")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Add_Find",Add_Find "realTestFind s") : string * tac*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Specify_Theory",Specify_Theory "Test") : string * tac*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Specify_Problem",Specify_Problem ["calculate","test"])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Specify_Method",Specify_Method ("Test","test_calculate"))*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Apply_Method",Apply_Method ("Test","test_calculate"))*)

val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Calculate",Calculate "PLUS")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Calculate",Calculate "TIMES")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Calculate",Calculate "DIVIDE")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Calculate",Calculate "POWER")*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("Check_Postcond",Check_Postcond ["calculate","test"])*)
val (p,_,f,nxt,_,pt) = me nxt p [1] pt;
(*nxt = ("End_Proof'",End_Proof')*)
if f = Form' (FormKF (~1,EdUndef,0,Nundef,"16")) then ()
else error "calculate.sml: script test_calculate changed behaviour";



"----------- calculate check test-root-equ --------------";
"----------- calculate check test-root-equ --------------";
"----------- calculate check test-root-equ --------------";
(*(1): 2nd Test_simplify didn't work:
val ct =
  "sqrt (x ^^^ 2 + -3 * x) = (-3 + 2 * x + -1 * (9 + 4 * x)) / (-1 * 2)"
> val rls = ("Test_simplify");
> val (ct,_) = the (rewrite_set thy' ("tval_rls") false rls ct);
val ct = "sqrt (x ^^^ 2 + -3 * x) =
(-9) / (-2) + (-3 / (-2) + (x * ((-4) / (-2)) + x * (2 / (-2))))";
ie. cancel does not work properly
*)
 val thy = "Test";
 val op_ = "DIVIDE";
 val ct = "sqrt (x ^^^ 2 + -3 * x) =\
 \(-9) / (-2) + (-3 / (-2) + (x * ((-4) / (-2)) + x * (2 / (-2))))";
 val SOME (ct,_) = calculate thy (the(assoc(calclist,op_))) ct;
 writeln ct;
(*
           sqrt (x ^^^ 2 + -3 * x) =\
 \(-9) / (-2) + (-3 / (-2) + (x * ((-4) / (-2)) + x * (2 / (-2))))
............... does not work *)

(*--------------(2): does divide work in Test_simplify ?: ------*)
 val thy = Test.thy;
 val t = (term_of o the o (parse thy)) "6 / 2";
 val rls = Test_simplify;
 val (t,_) = the (rewrite_set_ thy false rls t);
(*val t = Free ("3","RealDef.real") : term*)

 val thy = "Test";
 val t = "6 / 2";
 val rls = "Test_simplify";
 val (t,_) = the (rewrite_set thy false rls t);
(*val t = "3" : string
      ....... works, thus: which rule in SqRoot_simplify works differently ?*)


(*--------------(3): is_const works ?: -------------------------------------*)
 val t = (term_of o the o (parse Test.thy)) "2 is_const";
 atomty t;
 rewrite_set_ Test.thy false tval_rls t;
(*val it = SOME (Const ("True","bool"),[]) ... works*)

 val t = str2term "2 * x is_const";
 val SOME (str,t') = eval_const "" "" t Isac.thy;
 term2str t';
 

"----------- check calculate bottom up ------------------";
"----------- check calculate bottom up ------------------";
"----------- check calculate bottom up ------------------";
(*-------------- eval_cancel works: *)
 trace_rewrite:=true;
 val thy = Test.thy;
 val t = (term_of o the o (parse thy)) "(-4) / 2";
 val SOME (_,t) = eval_cancel "xxx" "HOL.divide" t thy;
 term2str t;
"-4 / 2 = (-2)";
(*-------------- but ... *)
 val ct = "x + (-4) / 2";
 val (ct,_) = the (rewrite_set thy' false rls ct);
"(-2) + x";
(*-------------- while ... *)
 val ct = "(-4) / 2";
 val (ct,_) = the (rewrite_set thy'  false rls ct);
"-2";

(*--------------(5): reproduce (1) with simpler term: ------------*)
 val thy = "Test";
 val t = "(3+5)/2";
 val (t,_) = the (rewrite_set thy false rls t);
(*val t = "4" ... works*)

 val t = "(3+1+2*x)/2";
 val (t,_) = the (rewrite_set thy false rls t);
(*val t = "2 + x" ... works*)

 trace_rewrite:=true; (*3.6.03*)
 val thy = "Test";
 val rls = "Test_simplify";
 val t = "(3+(1+2*x))/2";
 val (t,_) = the (rewrite_set thy false rls t);
(*val t = "2 + x" ... works: give up----------------------------------------*)
 trace_rewrite:=false; 

 trace_rewrite:=true; (*3.6.03*)
 val thy = Test.thy;
 val rls = Test_simplify;
 val t = str2term "(3+(1+2*x))/2";
 val SOME (t',asm) = rewrite_set_ thy false rls t;
 term2str t';
(*val t = "2 + x" ... works: give up----------------------------------------*)
 trace_rewrite:=false; 




(*--- trace_rewrite before correction of ... --------------------
 val ct = "(-3 + 2 * x + -1) / 2";
 val (ct,_) = the (rewrite_set thy'  false rls ct);
:
### trying thm 'root_ge0_2'
### rewrite_set_: x + (-1 + -3) / 2
### trying thm 'radd_real_const_eq'
### trying thm 'radd_real_const'
### rewrite_set_: x + (-4) / 2
### trying thm 'rcollect_right'
:
"x + (-4) / 2"
-------------------------------------while before Isabelle20002:
 val ct = "(#-3 + #2 * x + #-1) // #2";
 val (ct,_) = the (rewrite_set thy'  false rls ct);
:
### trying thm 'root_ge0_2'
### rewrite_set_: x + (#-1 + #-3) // #2
### trying thm 'radd_real_const_eq'
### trying thm 'radd_real_const'
### rewrite_set_: x + #-4 // #2
### rewrite_set_: x + #-2
### trying thm 'rcollect_right'
:
"#-2 + x"
-----------------------------------------------------------------*)


 toggle trace_rewrite;
(*===================*)
 trace_rewrite:=true;
 val thy' = "Test";
 val rls = "Test_simplify";		
 val ct = "x + (-1 + -3) / 2";
 val (ct,_) = the (rewrite_set thy'  false rls ct);	
"x + (-4) / 2";						
(*
### trying calc. 'cancel'
@@@ get_pair: binop, t = x + (-4) / 2
@@@ get_pair: t else
@@@ get_pair: t else -> NONE
@@@ get_pair: binop, t = (-4) / 2
@@@ get_pair: then 1
@@@ get_pair: t -> NONE
@@@ get_pair: t1 -> NONE
@@@ get_calculation: NONE
### trying calc. 'pow'
*)

 trace_rewrite:=true;
 val thy' = "Test";
 val rls = "Test_simplify";		
 val ct = "x + (-4) / 2";
 val (ct,_) = the (rewrite_set thy'  false rls ct);	
"(-2) + x";
(*
### trying calc. 'cancel'
@@@ get_pair: binop, t = x + -4 / 2
@@@ get_pair: t else
@@@ get_pair: t else -> NONE
@@@ get_pair: binop, t = -4 / 2
@@@ get_pair: then 1
@@@ get_calculation: SOME #cancel_-4_2
### calc. to: x + (-2)
### trying calc. 'cancel'
*)
 trace_rewrite:=false;

" ================= calculate.sml:10.8.02 2002:///->/ ======== ";
" ================= calculate.sml:10.8.02 2002:///->/ ======== ";
" ================= calculate.sml:10.8.02 2002:///->/ ======== ";
" ----------------- rewriting works ? -----------------------";
 val thy = Isac.thy;
 val prop = (#prop o rep_thm) real_divide_1;
 atomty prop;
(*** -------------
*** Const ( Trueprop, bool => prop)
*** . Const ( op =, [real, real] => bool)
*** . . Const ( HOL.divide, [real, real] => real)
*** . . . Var ((x, 0), real)
*** . . . Const ( 1, real)
*** . . Var ((x, 0), real) *)
 val prop' = (#prop o rep_thm o num_str) real_divide_1;
 atomty prop';
(*** -------------
*** Const ( Trueprop, bool => prop)
*** . Const ( op =, [real, real] => bool)
*** . . Const ( HOL.divide, [real, real] => real)
*** . . . Var ((x, 0), real)
*** . . . Free ( 1, real)   (*app_num_tr'*)
*** . . Var ((x, 0), real)*)
 val t = (term_of o the o (parseold thy)) "aaa/1";
 atomty t;
(*** -------------
*** Const ( HOL.divide, ['a, 'a] => 'a)
*** . Free ( aaa, 'a)
*** . Free ( 1, 'a) *)
 val t = (term_of o the o (parse thy)) "aaa/1";
 atomty t;
(*** -------------
*** Const ( HOL.divide, [real, real] => real)
*** . Free ( aaa, real)
*** . Free ( 1, real)  *)
 val thm = num_str real_divide_1;
 val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
(*val t = Free ("aaa","RealDef.real") : term*)


 val prop = (#prop o rep_thm) realpow_eq_one;
 atomty prop;
(*** -------------
*** Const ( Trueprop, bool => prop)
*** . Const ( op =, [real, real] => bool)
*** . . Const ( Nat.power, [real, nat] => real)
*** . . . Const ( 1, real)
*** . . . Var ((n, 0), nat)
*** . . Const ( 1, real) *)
 val prop' = (#prop o rep_thm o num_str) realpow_eq_one;
 atomty prop';
(*** -------------
*** Const ( Trueprop, bool => prop)
*** . Const ( op =, [real, real] => bool)
*** . . Const ( Nat.power, [real, nat] => real)
*** . . . Free ( 1, real)
*** . . . Var ((n, 0), nat)
*** . . Free ( 1, real)*)
 val t = (term_of o the o (parseold thy)) "1 ^ aaa";
 atomty t;
(*** -------------
*** Const ( Nat.power, ['a, nat] => 'a)
*** . Free ( 1, 'a)
*** . Free ( aaa, nat) *)
 val t = (term_of o the o (parse thy)) "1 ^ aaa";
 atomty t;
(*** -------------
*** Const ( Nat.power, [real, nat] => real)
*** . Free ( 1, real)
*** . Free ( aaa, nat) .......................... nat !!! *)
 val thm = num_str realpow_eq_one;
 val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
(*val t = Free ("1","RealDef.real") : term*)

" ================= calculate.sml: calculate_ 2002 =================== ";
" ================= calculate.sml: calculate_ 2002 =================== ";
" ================= calculate.sml: calculate_ 2002 =================== ";

val thy = Test.thy;
val t = (term_of o the o (parse thy)) "12 / 3";
val SOME (thmID,thm) = get_calculation_ thy(the(assoc(calclist,"DIVIDE")))t;
val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
"12 / 3 = 4";
val thy = Test.thy;
val t = (term_of o the o (parse thy)) "4 ^^^ 2";
val SOME (thmID,thm) = get_calculation_ thy(the(assoc(calclist,"POWER"))) t;
val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
"4 ^ 2 = 16";

 val t = (term_of o the o (parse thy)) "((1 + 2) * 4 / 3) ^^^ 2";
 val SOME (thmID,thm) = get_calculation_ thy (the(assoc(calclist,"PLUS"))) t;
"1 + 2 = 3";
 val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
 term2str t;
"(3 * 4 / 3) ^^^ 2";
 val SOME (thmID,thm) = get_calculation_ thy (the(assoc(calclist,"TIMES")))t;
"3 * 4 = 12";
 val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
 term2str t;
"(12 / 3) ^^^ 2";
 val SOME (thmID,thm) =get_calculation_ thy(the(assoc(calclist,"DIVIDE")))t;
"12 / 3 = 4";
 val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
 term2str t;
"4 ^^^ 2";
 val SOME (thmID,thm) = get_calculation_ thy(the(assoc(calclist,"POWER")))t;
"4 ^^^ 2 = 16";
 val SOME (t,_) = rewrite_ thy tless_true tval_rls true thm t;
 term2str t;
"16";
 if it <> "16" then error "calculate.sml: new behaviour in calculate_"
 else ();

(*13.9.02 *** calc: operator = pow not defined*)
  val t = (term_of o the o (parse thy)) "3^^^2";
  val SOME (thmID,thm) = 
      get_calculation_ thy (the(assoc(calclist,"POWER"))) t;
(*** calc: operator = pow not defined*)

  val (op_, eval_fn) = the (assoc(calclist,"POWER"));
  (*
val op_ = "Atools.pow" : string
val eval_fn = fn : string -> term -> theory -> (string * term) option*)

  val SOME (thmid,t') = get_pair thy op_ eval_fn t;
(*** calc: operator = pow not defined*)

  val SOME (id,t') = eval_fn op_ t thy;
(*** calc: operator = pow not defined*)

  val (thmid, (Const (op0,t0) $ Free (n1,t1) $ Free(n2,t2))) = (op_, t);
  val SOME (id,t') = eval_binop thmid op_ t thy;
(*** calc: operator = pow not defined*)

 
"----------- get_pair with 3 args --------------------------------";
"----------- get_pair with 3 args --------------------------------";
"----------- get_pair with 3 args --------------------------------";
val (thy, op_, ef, arg) =
    (thy, "EqSystem.occur'_exactly'_in", 
     snd (the (assoc(!calclist',"occur_exactly_in"))),
     str2term
      "[] from_ [c, c_2, c_3, c_4] occur_exactly_in -1 * (q_0 * L ^^^ 2) / 2"
      );
val SOME (str, simpl) = get_pair thy op_ ef arg;
if str = 
"[] from_ [c, c_2, c_3, c_4] occur_exactly_in -1 * (q_0 * L ^^^ 2) / 2 = True"
then () else error "calculate.sml get_pair with 3 args:occur_exactly_in";


"----------- calculate (2 * x is_const) -----------------";
"----------- calculate (2 * x is_const) -----------------";
"----------- calculate (2 * x is_const) -----------------";
val t = str2term "2 * x is_const";
val SOME (str, t') = eval_const "" "" t Test.thy;
term2str t';
"(2 * x is_const) = False";

val SOME (t',_) = rewrite_set_ Test.thy false tval_rls t;
term2str t';
"False";
===== inhibit exn ?===========================================================*)
